//
//  JDBaseViewController.h
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/4.
//  Copyright © 2018年 pengdandan. All rights reserved.
//
/*----------------------------------------------------------------
 // Copyright (C) 2018 京东云
 // 版权所有。
 //
 // 文件功能描述：页面基类 包含了发送http请求和解析的相关方法以及定制导航栏返回按钮
 原则上所有页面都得继承自此类
 //
 ----------------------------------------------------------------*/

#import <UIKit/UIKit.h>
#import "JDStaticTools.h"
#import "JDActionController.h"
#import "JDHttpRequest.h"
#import "MBProgressHUD+Help.h"
#import "JDMainManager.h"
//#import "JDCloudAppUtil.h"

@interface JDBaseViewController : UIViewController <UIActionSheetDelegate,HttpRequestDelegate>

@property (retain, nonatomic) JDHttpRequest *httpRequst;       //http请求类

#pragma mark -
#pragma mark - 返回
//在基类的viewdidload里调用 不需要返回按钮或需定制和基类不一样的按钮时 可在子类里自行处理
- (void)initNavgationcontrollerLeftButton;

//返回
- (void)back;

//推到目标页面
- (void)pushTargetVCWithClassString:(NSString *)classString;


//获取view的控制器对象
- (UIViewController *)getCurrentViewControllerWithView:(UIView *)view;

#pragma mark-
#pragma mark-- 发送请求
//发送GET请求
- (void)sendGetRequstToUrl:(NSString *)url withParam:(NSString*)str withTag:(int)tag;

//发送POST请求
- (void)sendPostRequestToUrl:(NSString*)url withParam:(NSDictionary*)dic withTag:(int)tag;

//取消http请求
- (void)cancelRequest;

//网络检查失败处理
- (void)netWorkFailed;

#pragma mark-
#pragma mark-- 请求解析 子类重写
//http请求成功回调
- (void)RequestSuccessWithDataDic:(NSDictionary *)data withTag:(int)tag;

//http请求失败回调
- (void)RequestFailedWithErr:(NSError*)error withTag:(int)tag;

@end
