//
//  JDBaseViewController.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/4.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDBaseViewController.h"

@interface JDBaseViewController ()

@end

@implementation JDBaseViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    //背景色
    self.view.backgroundColor = [JDStaticTools  colorWithHexString:kJDVCBackgroundColor];
   
    //定制导航栏
    [self setBaseNavigationBar];

    //定制导航栏返回按钮
    [self initNavgationcontrollerLeftButton];
    
    //请求
    self.httpRequst = [[JDHttpRequest alloc]init];
    self.httpRequst.delegate = self;
}


#pragma mark-
#pragma mark--定制导航栏左侧返回按钮
/**
 导航栏设置，全局有效
 */
- (void)setBaseNavigationBar{
    
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    [self.navigationController.navigationBar setTranslucent:true];
    [self.navigationController.navigationBar setBackgroundImage:[JDStaticTools imageWithColor:[JDStaticTools  colorWithHexString:kJDVCBackgroundColor]] forBarMetrics:UIBarMetricsDefault];
   // [self.navigationController.navigationBar setShadowImage:[UIImage new]];
    self.navigationController.navigationBar.tintColor = [UIColor whiteColor];
    [self.navigationController.navigationBar setTitleTextAttributes:@{NSForegroundColorAttributeName:[UIColor whiteColor]}];
}

/**
 *  定制返回按钮  在基类的viewdidload里调用 不需要返回按钮或需定制和基类不一样的按钮时 可在子类里自行处理
 */
- (void)initNavgationcontrollerLeftButton
{
    UIButton* leftBtn = [JDStaticTools  setNavigationLeftItem:self title:@"" withFontSize:15 textColor:[UIColor orangeColor] normalImageName:@"返回" hightLightedImageName:@"返回"];
    [leftBtn addTarget:self action:@selector(back) forControlEvents:UIControlEventTouchUpInside];
}

- (void)back
{
   // [self cancelRequest]; //点击返回按钮时 发送取消请求消息
    [self.navigationController popViewControllerAnimated:YES];
}

//推到目标页面
- (void)pushTargetVCWithClassString:(NSString *)classString{
    Class viewControllerClass = NSClassFromString(classString);
    if (viewControllerClass) {
        UIViewController *targetVC = [[viewControllerClass alloc]init];
        if (targetVC) {
            [self.navigationController pushViewController:targetVC animated:true];
        }
    }
}

//获取view的控制器对象
- (UIViewController *)getCurrentViewControllerWithView:(UIView *)view{
    UIResponder *next = [view nextResponder];
    do {
        if ([next isKindOfClass:[UIViewController class]]) {
            return (UIViewController *)next;
        }
        next = [next nextResponder];
    } while (next != nil);
    return nil;
}


- (BOOL)shouldAutorotate
{
    return NO;
}

#pragma mark-
#pragma mark-- 发送请求
//发送GET请求
- (void)sendGetRequstToUrl:(NSString *)url withParam:(NSString*)str withTag:(int)tag{
    [self  cancelRequest];
    if ([JDStaticTools checkNetWork] > 0){
        [self.httpRequst sendGetRequstToUrl:url withParam:str withTag:tag];
    }else{
        [self netWorkFailed];
    }
}

//发送POST请求
- (void)sendPostRequestToUrl:(NSString*)url withParam:(NSDictionary*)dic withTag:(int)tag{
    [self cancelRequest];
    if ([JDStaticTools checkNetWork] > 0){
        [self.httpRequst sendPostRequestToUrl:url withParam:dic withTag:tag];
    }else{
        [self netWorkFailed];
    }
}

//取消http请求
- (void)cancelRequest{
    [self.httpRequst cancelRequest];
}

/*
 *网络检查失败处理
 */
- (void)netWorkFailed
{
    [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"您的网络好像有问题，请检查。"];
}

#pragma mark-
#pragma mark-- 请求解析
//http请求成功回调
- (void)RequestSuccessWithDataDic:(NSDictionary *)data withTag:(int)tag{
}

//http请求失败回调
- (void)RequestFailedWithErr:(NSError*)error withTag:(int)tag{
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
