//
//  JDHttpRequest.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/4.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDHttpRequest.h"
@interface JDHttpRequest()
{
    NSURLSessionDataTask *sessionDataTask;
}
@end

@implementation JDHttpRequest

//发送GET请求
- (void)sendGetRequstToUrl:(NSString *)url withParam:(NSString*)str withTag:(int)tag
{
    NSString* urlStr = [NSString stringWithFormat:@"%@%@",url,str];
    NSLog(@"发送请求：%@",urlStr);
    NSURLRequest *urlRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:urlStr] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:5];
    NSURLSession *urlSession = [NSURLSession sharedSession];
    sessionDataTask = [urlSession dataTaskWithRequest:urlRequest completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if (!error) {
            NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil];
            NSLog(@"返回数据：%@",dict);
            if (self.delegate && [self.delegate respondsToSelector:@selector(RequestSuccessWithDataDic:withTag:)]){
                [self.delegate RequestSuccessWithDataDic:dict withTag:tag];
            }
        }else{
            if (self.delegate && [self.delegate respondsToSelector:@selector(RequestFailedWithErr:withTag:)]){
                NSLog(@"返回数据：%@",error);
                [self.delegate RequestFailedWithErr:error withTag:tag];
            }
        }
    }];
    [sessionDataTask resume];
}

//发送POST请求
- (void)sendPostRequestToUrl:(NSString*)url withParam:(NSDictionary*)dic withTag:(int)tag;
{
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
    request.timeoutInterval = 5;
    request.HTTPMethod = @"POST";
    NSError *error = nil;
    NSData *data = [NSJSONSerialization dataWithJSONObject:dic options:0 error:&error];
    [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    request.HTTPBody = data;
    NSURLSession *session = [NSURLSession sharedSession];
    sessionDataTask = [session dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        if(!error){
            NSDictionary *dict = [NSJSONSerialization JSONObjectWithData:data options:(NSJSONReadingMutableLeaves) error:nil];
            NSLog(@"返回数据：%@",dict);
            if (self.delegate && [self.delegate respondsToSelector:@selector(RequestSuccessWithDataDic:withTag:)]){
                [self.delegate RequestSuccessWithDataDic:dict withTag:tag];
            }
        }else{
            if (self.delegate && [self.delegate respondsToSelector:@selector(RequestFailedWithErr:withTag:)]){
                NSLog(@"返回数据：%@",error);
                [self.delegate RequestFailedWithErr:error withTag:tag];
            }
        }
    }];
    [sessionDataTask resume];
}

//取消请求
- (void)cancelRequest{
    [sessionDataTask cancel];
}

@end
