//
//  JDStaticTools.h
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/5.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "JDStaticTools.h"
#import "JDScanViewController.h"

@interface JDStaticTools : NSObject

/*
 *设置navigationBar的左按钮样式
 */
+ (UIButton*)setNavigationLeftItem:(UIViewController *)viewController
                             title:(NSString *)title
                      withFontSize:(CGFloat)fontSize
                         textColor:(UIColor*)textColor
                   normalImageName:(NSString *)normalImageName
             hightLightedImageName:(NSString *)hightLightedImageName;

/*
 *设置navigationBar的右按钮样式
 */
+ (UIButton*)setNavigationRightItem:(UIViewController *)viewController
                              title:(NSString *)title
                       withFontSize:(CGFloat)fontSize
                          textColor:(UIColor*)textColor
                    normalImageName:(NSString *)normalImageName
              hightLightedImageName:(NSString *)hightLightedImageName;

/*
 @abstract 16进制颜色(html颜色值)字符串转为UIColor
 */
+ (UIColor *) colorWithHexString:(NSString *)stringToConvert;

/*
 @abstract 16进制颜色(html颜色值)字符串转为UIColor  alpha透明度
 */
+ (UIColor *)colorWithHexString:(NSString *)hexStr alpha:(CGFloat)alpha;

/**
 @abstract 根据颜色返回图片
 */
+ (UIImage*) imageWithColor:(UIColor*)color;

/*
 @abstract 将tableview 去掉cell多余的分割线
 */
+ (void)setExtraCellLineHidden: (UITableView *)tableView;

/*
 @abstract 创建Label
 */
+ (UILabel*)setupLabelframe:(CGRect)frame
                       text:(NSString *)text
                   fontSize:(CGFloat)fontSize
                  textColor:(UIColor*)textColor
              textAlignment:(NSTextAlignment)textAlignment;

/*
 @abstract 创建Button
 */
+ (UIButton*)setupButtonframe:(CGRect)frame
                        title:(NSString *)title
                     fontSize:(CGFloat)fontSize
                    textColor:(UIColor*)textColor
              normalImageName:(NSString *)normalImageName
        hightLightedImageName:(NSString *)hightLightedImageName
                          tag:(NSInteger)tag;

/**
 @abstract 当前的时间字符串
 */
+ (NSString *)currentDateString;

/*
 @abstract 取得今天的日期 yyyy/MM/dd
 */
+ (NSString *)getTodayDateStr;

/**
 @abstract 是否时竖屏
 */
+ (BOOL)isInterfaceOrientationPortrait;

/**
 @abstract 播放时间显示格式处理
 */
+ (NSString *)timeformatFromSeconds:(NSInteger)seconds;

/*
 @abstract NSTimeInterval 转 NSString
 */
+ (NSString*)stringWithNSTimeInterval:(NSTimeInterval)time;

/*
 @abstract 检查网络状态
 */
+ (int)checkNetWork;

/*
 @abstract 获取手机当前网络类型
 */
+ (NSString *)networkType;

/*
 @abstract 图片库bundle
 */
+ (NSBundle *)resourceBundle;
    
+ (NSString *)dictionary2JsonString:(NSDictionary *)dict;

+ (NSDictionary *)jsonData2Dictionary:(NSString *)jsonData;

@end
