//
//  JDActionSheet.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/20.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDActionController.h"

@implementation JDActionController

/*
 @abstract alert实现aLert、Sheet代理的时候
 */

- (void)showAlertControllerWithTitle:(nullable NSString *)title
                             message:(nullable NSString *)message
                      preferredStyle:(UIAlertControllerStyle)preferredStyle
                   otherButtonTitles:(NSArray *)titlesArray
                 superViewController:(UIViewController*)superViewController
               actionControllerBlock:(ActionControllerBlock)succBlock
{
    self.succBlock = succBlock;
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:preferredStyle];
    for (NSString *actionSheetTitle in titlesArray)
    {
        UIAlertAction *actionSheetAction = [UIAlertAction actionWithTitle:actionSheetTitle style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action)
        {
            if(self.succBlock){
                self.succBlock(actionSheetTitle);
            }
        }];
        [alertController addAction:actionSheetAction];
    }
    [superViewController presentViewController:alertController animated:YES completion:nil];
}



@end
