//
//  JDMainChartView.m
//  JDCloudChart
//
//  Created by 彭丹丹 on 2018/11/26.
//  Copyright © 2018年 彭丹丹. All rights reserved.
//

#import "JDMainChartView.h"
#import "JDKLineChart.h"
#import "JDLineModel.h"

@interface JDMainChartView ()<UIScrollViewDelegate>

@property (nonatomic ,strong) UIButton* timeStatisticsButton;               //分时统计Btn
@property (nonatomic, strong) NSArray<UIButton *> *timeStatisticsBtns;      //分时统计Btns
@property (nonatomic ,strong) UIScrollView*  timeStatisticsSV;              //分时统计SV
@property (nonatomic ,strong) NSMutableArray *timeStatisticsBtnTitleArr;    //分时统计选择的button的title

@property (nonatomic ,strong) UIButton* packteStatisticsButton;             //分包统计Btn
@property (nonatomic, strong) NSArray<UIButton *> *packteStatisticsBtns;    //分包统计Btns
@property (nonatomic ,strong) UIScrollView*  packteStatisticsSV;            //分包统计SV
@property (nonatomic ,strong) NSMutableArray *packteStatisticsBtnTitleArr;  //分包统计选择的button的title

@property (nonatomic ,strong) JDKLineChart* KLineChartView;

@end

@implementation JDMainChartView

- (instancetype)initWithFrame:(CGRect)frame{
    if (self = [super initWithFrame:frame]) {
        [self addSubviews];
    }
    return self;
}

- (void)addSubviews{
    
    //分时统计
    self.timeStatisticsButton = [[UIButton alloc]initWithFrame:CGRectMake(0, self.frame.size.height - 30, ScreenWidth/2, 30)];
    _timeStatisticsButton.backgroundColor = [UIColor darkGrayColor];
    _timeStatisticsButton.alpha = 0.5;
    [_timeStatisticsButton setTitle:@"分时统计" forState:UIControlStateNormal];
    [_timeStatisticsButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [_timeStatisticsButton setTitleColor:[UIColor blackColor] forState:UIControlStateSelected];
    _timeStatisticsButton.tag = 100;
    [_timeStatisticsButton addTarget:self action:@selector(bttonClickAction:) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:self.timeStatisticsButton];

    self.timeStatisticsSV = [[UIScrollView alloc]initWithFrame:CGRectMake(0, self.frame.size.height - 60, ScreenWidth, 30)];
    [self addSubview:self.timeStatisticsSV];
    
    NSArray* _timeStatisticsArr = @[@"inTotalBytes",@"outTotalBytes",@"bufferVideoBytes",@"dropBytes"];
    self.timeStatisticsBtns = [self creatButtonswithArr:_timeStatisticsArr isTimeStatistics:YES];
  
    //分包统计
    self.packteStatisticsButton = [[UIButton alloc]initWithFrame:CGRectMake(ScreenWidth/2+1, self.frame.size.height - 30, ScreenWidth/2, 30)];
    _packteStatisticsButton.backgroundColor = [UIColor darkGrayColor];
    _packteStatisticsButton.alpha = 0.5;
    [_packteStatisticsButton setTitle:@"分包统计" forState:UIControlStateNormal];
    [_packteStatisticsButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [_packteStatisticsButton setTitleColor:[UIColor blackColor] forState:UIControlStateSelected];
    [_packteStatisticsButton addTarget:self action:@selector(bttonClickAction:) forControlEvents:UIControlEventTouchUpInside];
    _packteStatisticsButton.tag = 101;
    [self addSubview:self.packteStatisticsButton];
    
    self.packteStatisticsSV = [[UIScrollView alloc]initWithFrame:CGRectMake(0, self.frame.size.height - 60, ScreenWidth, 30)];
    [self addSubview:self.packteStatisticsSV];
    
    NSArray* _packteStatisticsArr = @[@"inVideoPackets",@"outVideoPackets",@"bufferVideoPackets",@"dropPackets"];
    self.packteStatisticsBtns = [self creatButtonswithArr:_packteStatisticsArr isTimeStatistics:NO];

    self.KLineChartView = [[JDKLineChart alloc]initWithFrame:CGRectMake(0, 100, ScreenWidth, 350)];
    self.KLineChartView.alpha = 0.5;
    [self addSubview:self.KLineChartView];
    
    //默认选中分时统计
    [self bttonClickAction:_timeStatisticsButton];
    //默认分时统计inTotalBytes
    self.timeStatisticsBtnTitleArr = [NSMutableArray arrayWithObjects:@"inTotalBytes", nil];
    self.timeStatisticsBtns[0].selected = YES;
    [self.KLineChartView drawKLineWithLineArr:self.timeStatisticsBtnTitleArr WithStatisticsType:0];
    //默认分包统计inVideoPackets
    self.packteStatisticsBtnTitleArr = [NSMutableArray arrayWithObjects:@"inVideoPackets", nil];
    self.packteStatisticsBtns[0].selected = YES;
}

- (void)bttonClickAction:(UIButton*)sender {
    UIButton* button = (UIButton*)sender;
    switch (button.tag) {
        case 100:
        {
            self.timeStatisticsButton.selected = YES;
            self.packteStatisticsButton.selected = NO;
            self.timeStatisticsSV.hidden = NO;
            self.packteStatisticsSV.hidden = YES;
            [self.KLineChartView drawKLineWithLineArr:self.timeStatisticsBtnTitleArr WithStatisticsType:0];
        }
            break;
        case 101:
        {
            self.timeStatisticsButton.selected = NO;
            self.packteStatisticsButton.selected = YES;
            self.timeStatisticsSV.hidden = YES;
            self.packteStatisticsSV.hidden = NO;
            [self.KLineChartView drawKLineWithLineArr:self.packteStatisticsBtnTitleArr WithStatisticsType:1];
        }
            break;
        default:
            break;
    }
}

//分时统计 几种类型 点击事件
- (void)bttonClickTimeStatisticsAction:(UIButton*)sender {
    UIButton* button = (UIButton*)sender;
    button.selected = !button.selected;
    [self drawKLineArrwithSelectedBtton:button KLineSelectedBtnArr:self.timeStatisticsBtnTitleArr withLineName:button.titleLabel.text];
    [self.KLineChartView drawKLineWithLineArr:self.timeStatisticsBtnTitleArr WithStatisticsType:0];
}

//分包统计 几种类型 点击事件
- (void)bttonClickPackteStatisticsAction:(UIButton*)sender {
    UIButton* button = (UIButton*)sender;
    button.selected = !button.selected;
    [self drawKLineArrwithSelectedBtton:button KLineSelectedBtnArr:self.packteStatisticsBtnTitleArr withLineName:button.titleLabel.text];
    [self.KLineChartView drawKLineWithLineArr:self.packteStatisticsBtnTitleArr WithStatisticsType:1];
}

//画K线上要显示哪写线
- (void)drawKLineArrwithSelectedBtton:(UIButton*)sender KLineSelectedBtnArr:(NSMutableArray *)arr withLineName:(NSString*)name{
    UIButton* button = (UIButton*)sender;
    if (button.selected) {
        [arr addObject:name];
    }else{
        for (int i = 0; i < arr.count ; i++ ) {
            if ([arr[i] isEqualToString:name]) {
                [arr removeObject:arr[i]];
            }
        }
    }
}

//按钮
- (NSArray<UIButton *> *)creatButtonswithArr:(NSArray*)arr isTimeStatistics:(BOOL)istime{
    
    CGFloat buttonWidth = ScreenWidth/4;
    NSMutableArray<UIButton *> *array = [NSMutableArray arrayWithCapacity:arr.count];
    for (NSInteger index = 0; index < arr.count; index++) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        button.frame = CGRectMake((int)(index%4) * buttonWidth+2, (int)(index/4) * 44, buttonWidth, 30);
        [button setTitle:arr[index] forState:UIControlStateNormal];
        [button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [button setTitleColor:[UIColor blackColor] forState:UIControlStateSelected];
        button.backgroundColor = [UIColor lightGrayColor];
        button.alpha = 0.5;
        button.titleLabel.font = [UIFont systemFontOfSize:10];
        [array addObject:button];
        
        if(istime){
            [self.timeStatisticsSV addSubview:button];
            button.tag = index + 200;
            [button addTarget:self action:@selector(bttonClickTimeStatisticsAction:) forControlEvents:UIControlEventTouchUpInside];
        }else{
            [self.packteStatisticsSV addSubview:button];
            button.tag = index + 300;
            [button addTarget:self action:@selector(bttonClickPackteStatisticsAction:) forControlEvents:UIControlEventTouchUpInside];
        }
    }
    return [array copy];
}

@end

