//
//  JDPhotoManager.h
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/19.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <AssetsLibrary/AssetsLibrary.h>

#define SharePhotoManager [JDPhotoManager sharedPhotoManager]

typedef void (^FinishPickingMediaBlock)(UIImage *assetImage, NSURL *assetURL);

@interface JDPhotoManager : NSObject<UIImagePickerControllerDelegate,UINavigationControllerDelegate,UIActionSheetDelegate>

@property (nonatomic, weak) UIViewController *fatherViewController;    //父类

@property (copy, nonatomic) FinishPickingMediaBlock succBlock;


/*
 * 单例
 */
+ (instancetype)sharedPhotoManager;


/**
 *  图片、视频
 *
 *  @param fatherVC       Sheet显示在fatherVC.view上
 *  @param succBlock      选择之后获取的媒体
 */

- (void)ShowSheetToSelectedMediaWithInFatherVC:(UIViewController *)fatherVC
                                FinishPickingMediaBlock:(FinishPickingMediaBlock)succBlock;

@end
