//
//  MBProgressHUD+Help.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/29.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "MBProgressHUD+Help.h"

MBProgressHUD *HUD;
@implementation MBProgressHUD (Help)

/*
 /// 显示样式
 typedef NS_ENUM(NSInteger, MBProgressHUDMode) {
 /// 默认模式, 系统自带的指示器
 MBProgressHUDModeIndeterminate,
 /// 圆形饼图
 MBProgressHUDModeDeterminate,
 /// 水平进度条
 MBProgressHUDModeDeterminateHorizontalBar,
 /// 圆环
 MBProgressHUDModeAnnularDeterminate,
 /// 自定义视图
 MBProgressHUDModeCustomView,
 /// 只显示文字
 MBProgressHUDModeText
 };
 
动画效果 animationType
 typedef NS_ENUM(NSInteger, MBProgressHUDAnimation) {
 ///  默认效果，只有透明度变化
 MBProgressHUDAnimationFade,
 /// 透明度变化 + 形变 (放大时出现缩小消失)
 MBProgressHUDAnimationZoom,
 /// 透明度变化 + 形变 (缩小)
 MBProgressHUDAnimationZoomOut,
 /// 透明度变化 + 形变 (放大)
 MBProgressHUDAnimationZoomIn
 };

 */

+ (void)showHUDInView:(UIView *)superView
              HudType:(MBProgressHUDMode)hudType
             withText:(NSString *)lableText
{
    HUD = [MBProgressHUD showHUDAddedTo:superView animated:true];
    HUD.mode = hudType;
    HUD.bezelView.style = MBProgressHUDBackgroundStyleSolidColor;
    HUD.bezelView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.6];
    HUD.contentColor = [UIColor whiteColor];
    HUD.label.numberOfLines = 10;
    HUD.label.text = lableText;
    
    switch (hudType) {
             // 自定义试图 几秒后消失
        case MBProgressHUDModeCustomView:
        {
            [HUD hideAnimated:true afterDelay:2];
        }
        break;
        case MBProgressHUDModeIndeterminate:
        {
            HUD.bezelView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.6];
            HUD.center = CGPointMake(HUD.center.x, [UIScreen mainScreen].bounds.size.height/2);
        }
            break;

        default:
        break;
    }
}

/*
 隐藏hud
 */
+ (void)removeHUDFromView:(UIView *)superView
{
    NSArray *hudArray = [self allHUDsForView:superView];
    for (MBProgressHUD *hud in hudArray){
        [hud removeFromSuperview];
    }
}

- (NSArray *)allHUDsForView:(UIView *)view {
    NSMutableArray *huds = [NSMutableArray array];
    NSArray *subviews = view.subviews;
    Class hudClass = [MBProgressHUD class];
    for (UIView *aView in subviews) {
        if ([aView isKindOfClass:hudClass]) {
            [huds addObject:aView];
        }
    }
    return [NSArray arrayWithArray:huds];
}

@end

