//
//  JDTimeRuningView.h
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/29.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

@protocol UpdateTimerDelegate <NSObject>

- (void)updateTimeWith:(UIView*)editView;
    
@end


@interface JDTimeRuningView : UIView

    
@property (nonatomic ,assign) BOOL  isHiddenRedPoint;           //是否隐藏小红点
    
@property(nullable, nonatomic,copy) UIColor *textColor;         //字体颜色
    
@property (nonatomic, weak) id<UpdateTimerDelegate> delegate;   //代理
    
    
- (instancetype)initWithFrame:(CGRect)frame isHiddenRedPoint:(BOOL)isHidden textColor:(UIColor*)color;
    
    //时间开始
- (void)startTimer:(JDTimeRuningView*)editView;
    
    //更新时间显示
- (void)setTimeLabelText:(NSInteger)seconds;
    
    //时间停止
- (void)stopTimer;
    
    //返回总共延续的时间
- (NSString*)durationTime;
    
@end

NS_ASSUME_NONNULL_END
