//
//  JDTimeRuningView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/29.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDTimeRuningView.h"

@interface JDTimeRuningView()
    
@property (nonatomic ,strong) UIImageView* redImageView;
@property (nonatomic ,strong) UILabel* timeLabel;
@property (nonatomic ,strong) NSTimer* timer;
    
@property (nonatomic ,strong) NSString* startTime;
@property (nonatomic ,strong) NSString* CurrTime;
    
@end


@implementation JDTimeRuningView

- (instancetype)initWithFrame:(CGRect)frame isHiddenRedPoint:(BOOL)isHidden textColor:(UIColor*)color
{
    self = [super initWithFrame:CGRectMake(frame.origin.x, frame.origin.y, 100, 17)];
    if (self) {
        [self addSubViewsIsHiddenRedPoint:isHidden textColor:color];
    }
    return self;
}
    
//增加子试图
- (void)addSubViewsIsHiddenRedPoint:(BOOL)isHidden textColor:(UIColor* )color
{
    //红点
    self.redImageView = [[UIImageView alloc]initWithFrame:CGRectMake(0, (17-9)/2, 9, 9)];
    self.redImageView.image = [UIImage imageNamed:@"直播中"];
    self.redImageView.hidden = isHidden;
    [self addSubview:self.redImageView];
    
    //时间
    self.timeLabel = [[UILabel alloc] initWithFrame:CGRectMake(18, 0, 80, 17)];
    self.timeLabel.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    self.timeLabel.textColor = color;
    self.timeLabel.text = @"00:00:00";
    [self addSubview:self.timeLabel];
    
    if (self.isHiddenRedPoint) {
        self.timeLabel.frame = CGRectMake(0, 0, 80, 17);
    }
}
    
//时间开始
- (void)startTimer:(JDTimeRuningView*)editView{
    self.timeLabel.text = @"";
    self.startTime = [JDStaticTools currentDateString];
    self.timer = [NSTimer scheduledTimerWithTimeInterval:0.1 target:self selector:@selector(getTimer:) userInfo:editView repeats:YES];
    [[NSRunLoop mainRunLoop] addTimer:self.timer forMode:NSRunLoopCommonModes];
    [self.timer fire];
}
    
    
//更新时间
- (void)getTimer:(NSTimer*)timer{
    //开始时间：
    self.CurrTime = [JDStaticTools currentDateString];
    if(self.delegate && [self.delegate respondsToSelector:@selector(updateTimeWith:)]){
        [self.delegate updateTimeWith:(JDTimeRuningView*)[timer userInfo]];
    }
}
    
//时间显示
- (void)setTimeLabelText:(NSInteger)seconds {
    if (seconds >= 0) {
        self.timeLabel.text = [self getMMSSFromSS:seconds];
    }else{
        self.timeLabel.text = [self timeWithStartTime:self.startTime IntervalSinceDate:self.CurrTime];
    }
}
    
//时间停止
- (void)stopTimer{
    [self.timer invalidate];
    self.timer = nil;
}
  
//总共延续的时间
- (NSString*)durationTime{
    NSString* totalTime = @"00:00:00";
    if (self.startTime.length>1 && self.startTime.length>1) {
      totalTime = [self timeWithStartTime:self.startTime IntervalSinceDate:self.CurrTime];
    }
    return totalTime;
}
    
//时间转化
- (NSString *)getMMSSFromSS:(NSInteger)seconds {
    
    //format of hour
    NSInteger hours = seconds / 3600;
    //format of minute
    NSInteger minutes = (seconds / 60) % 60;
    //format of second
    NSInteger secondss = seconds % 60;
    //format of time
    NSString *format_time = [NSString stringWithFormat:@"%02ld:%02ld:%02ld",hours,minutes,secondss];
    
    return format_time;
    
}

//相差时间
- (NSString*)timeWithStartTime:(NSString*)startTime IntervalSinceDate:(NSString*)stopTime{

    NSArray *array1 = [NSArray arrayWithArray:[startTime componentsSeparatedByString:@":"]];
    NSArray *array2 = [NSArray arrayWithArray:[stopTime componentsSeparatedByString:@":"]];
    
    NSInteger  seconds = ([array2[0] intValue] * 3600 + [array2[1] intValue]*60 + [array2[2] intValue]) - ([array1[0] intValue]*3600 + [array1[1] intValue]*60 + [array1[2] intValue]);

    NSString *format_time = [self getMMSSFromSS:seconds];
    
    return format_time;
}


@end
