//
//  JDCloudPlayerErrorView.h
//  IJKMediaDemo
//
//  Created by 王亚伟 on 2018/9/18.
//  Copyright © 2018年 wangyawei All rights reserved.
//

#import <UIKit/UIKit.h>
#import "JDCloudPrivateDefine.h"

@protocol JDCloudPlayerErrorViewDelegate <NSObject>

/*
 * 功能 ：错误状态提示
 * 参数 ： type 错误类型
 */
- (void)onErrorViewClickedWithType:(JDCloudErrorType)type;

@end

@interface JDCloudPlayerErrorView : UIView

@property (nonatomic, weak  ) id<JDCloudPlayerErrorViewDelegate> delegate;
@property (nonatomic, copy  ) NSString *message;                        //错误信息内容
@property (nonatomic, assign)JDCloudErrorType type;         //错误类型

/*
 * 功能 ：展示错误页面偏移量
 * 参数 ：parent 插入的界面
 */
- (void)showWithParentView:(UIView *)parent;

/*
 * 功能 ：是否展示界面
 */
- (BOOL)isShowing;

/*
 * 功能 ：是否删除界面
 */
- (void)dismiss;

@end
