//
//  JDPushFlowContextProtocol.h
//  jdcloud_ios_live_demo
//
//  Created by 熊勇 on 2018/9/25.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <Foundation/Foundation.h>

//直播状态变化通知
FOUNDATION_EXPORT NSString *const JDLPushStreamStateChangeNotification NS_AVAILABLE_IOS(7_0);
//直播错误发生通知
FOUNDATION_EXPORT NSString *const JDLPushStreamErrorNotification NS_AVAILABLE_IOS(7_0);
//直播网络状态改变通知
FOUNDATION_EXPORT NSString *const JDLNetworkStatusChangeNotification NS_AVAILABLE_IOS(7_0);
//直播录制状态改变通知
FOUNDATION_EXPORT NSString *const JDLMediaRecordStateChangeNotification NS_AVAILABLE_IOS(7_0);
//推流模式改变通知
FOUNDATION_EXPORT NSString *const JDLPushStreamModeChangeNotification NS_AVAILABLE_IOS(7_0);

@protocol JDPushFlowContextProtocol <NSObject>

//预览窗口
@property (nonatomic, strong) UIView *previewView;

//直播推流接口
@property (nonatomic, strong) JDLive *live;

@property (nonatomic, strong) JDLinkPK *linkLive;

@property (nonatomic, assign) BOOL isNeedFloatPush;

@property (nonatomic, assign) BOOL isOrientationLock;

@property (nonatomic, copy) NSString *strMusicUrl;

//当前选择的哪个音频调用的音乐
@property (nonatomic, assign) NSInteger currentSelectAudioIndex;

//是否镜像推流
@property (nonatomic, assign) BOOL isMirroredPush;

//是否自动对焦
@property (nonatomic, assign) BOOL isAutoFocus;

//连麦
- (void)onLinkRoomAction1:(NSDictionary*)dic;
- (void)onLinkRoomAction2:(NSDictionary*)dic;

//显示底部弹出view
- (void)showBottomPopupView:(UIView*)bottomView;

//关闭底部弹出view
- (void)closeBottomPopupView;
    
//推下一个VC
- (void)pushViewController:(UIViewController*)VC;

//关闭VC
- (void)popViewController;

//临时隐藏VC
- (void)hideViewController;

//显示VC
- (void)showViewController;

//销毁VC
- (void)releaseViewController;

@end




