//
//  JDAudioCallViewController.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/11.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDAudioCallViewController.h"
#import "JDStaticTools.h"


@interface JDAudioCallViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong) UITableView *listTableView;        //TableView
@property (nonatomic, strong) NSMutableArray *dataArray;         //TableView数据
@property (nonatomic, strong) UIButton* sureButton;              //确定

@end

@implementation JDAudioCallViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = @"音频调用";
    [self setupSubviews];
    [self setupDatas];
}

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden = NO;
}

#pragma mark -
#pragma mark - 初始化子试图
//初始化子试图
- (void)setupSubviews
{
    //TableView
    self.listTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight-60)];
    self.listTableView.delegate = (id)self;
    self.listTableView.dataSource = (id)self;
    self.listTableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    self.listTableView.separatorColor = [JDStaticTools colorWithHexString:@"#4f5161"];
    self.listTableView.separatorInset = UIEdgeInsetsMake(0,0, 0, 0);              // 设置端距，这里表示separator离左边和右边均0像素
    self.listTableView.backgroundColor = [UIColor clearColor];
    [self.view addSubview:self.listTableView];
    
    //去除tableView多余分割线
    [JDStaticTools setExtraCellLineHidden:self.listTableView];
    
    //确定按钮
    self.sureButton =  [UIButton buttonWithType:(UIButtonTypeCustom)];
    self.sureButton.frame = CGRectMake(0, ScreenHeight - 60 - SafeAreaBottomHeight, ScreenWidth, 60 + SafeAreaBottomHeight);
    [self.sureButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 0, self.sureButton.titleLabel.frame.origin.y + SafeAreaBottomHeight, 0)];
    [self.sureButton setTitle:@"确定" forState:UIControlStateNormal];
    self.sureButton.backgroundColor = RGBCOLOR(39, 47, 80);
    self.sureButton.tag  = 102;
    [self.sureButton setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [self.sureButton addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:self.sureButton];
}

#pragma mark -
#pragma mark - 初始化子试图
//初始化子试图
- (void)setupDatas
{
    NSArray* files = @[@"music1.mp3",@"music2.mp3",@"music3.mp3"];
    self.dataArray = [NSMutableArray arrayWithCapacity:1];
    [self.dataArray addObject:@{@"title":@"无",@"time":@"",@"file":@""}];
    for (int i = 0; i < files.count; i++){
        NSString* title = [files objectAtIndex:i];
        NSString* file = [NSString stringWithFormat:@"%@/%@",[[NSBundle mainBundle] resourcePath],title];
//        NSDictionary* dic = [JDCloudPlayerUtil getMeidaInfoWithUrl:[NSURL fileURLWithPath:file]];
        NSString* time = @"";
//        if (dic) {
//            int sec = [[dic objectForKey:@"duration"] doubleValue]/1000;
//            time = [JDStaticTools timeformatFromSeconds:sec];
//        }
        [self.dataArray addObject:@{@"title":title,@"time":time,@"file":file}];
    }
    [self.listTableView reloadData];
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    NSMutableDictionary* dic = self.dataArray[_currentSelectIndex];
    NSString* file = [dic objectForKey:@"file"];
    if(self.sureAction){
        self.sureAction(file,_currentSelectIndex);
    }
    [super back];
}

#pragma mark -
#pragma mark - TableViewDataSources
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identify = @"cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identify];
    if (cell == nil)
    {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:identify];
        [cell setSelectionStyle:UITableViewCellSelectionStyleDefault];
        cell.backgroundColor = [UIColor clearColor];
    }

    for (UIView *view in cell.contentView.subviews){
        [view removeFromSuperview];
    }
    
    UIImageView* imageView = [[UIImageView alloc]initWithImage:[UIImage imageNamed:@"音频调用_未选中"] highlightedImage:[UIImage imageNamed:@"音频调用_选中"]];
    imageView.frame = CGRectMake(35/2, 12, 20, 20);
    [imageView sizeToFit];
    [cell.contentView addSubview:imageView];
    
    if(_currentSelectIndex == indexPath.row)
    {
        imageView.highlighted = YES;
        cell.contentView.backgroundColor = [JDStaticTools colorWithHexString:@"#4f5161"];
    }
    else{
        imageView.highlighted = NO;
        cell.contentView.backgroundColor = [UIColor clearColor];
    }
    
    UILabel* audioLabel = [[UILabel alloc]initWithFrame:CGRectMake(87/2, 0, 100, 44)];
    audioLabel.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    audioLabel.textColor = [UIColor whiteColor];
    audioLabel.text = self.dataArray[indexPath.row][@"title"];
    [cell.contentView addSubview:audioLabel];
    
    UILabel* timeLabel = [[UILabel alloc]initWithFrame:CGRectMake(200, 0, 100, 44)];
    timeLabel.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    timeLabel.textColor = [UIColor whiteColor];
    timeLabel.text = self.dataArray[indexPath.row][@"time"];
    [cell.contentView addSubview:timeLabel];
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    self.currentSelectIndex = (int)indexPath.row;
    [self.listTableView reloadData];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
