//
//  JDLiveEndViewController.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/29.
//  Copyright © 2018年 pengdandan. All rights reserved.
// 直播结束页面

#import "JDLiveEndViewController.h"
#import "JDStartPushFlowViewController.h"
#import "ConfigPushFlowParamModel.h"
#import "AppDelegate.h"

@interface JDLiveEndViewController ()

@end

@implementation JDLiveEndViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setupSubviews];
    self.view.backgroundColor = [JDStaticTools colorWithHexString:kJDVCBackgroundColor];
    [self dismissDetailVC];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden = YES;
}

//销毁中间详情页控制器JDStartPushFlowViewController
- (void)dismissDetailVC
{
    NSMutableArray *marr = [[NSMutableArray alloc]initWithArray:self.navigationController.viewControllers];
    for (UIViewController *vc in marr) {
        if ([vc isKindOfClass:[JDStartPushFlowViewController class]]) {
            [marr removeObject:vc];
            break;
        }
    }
    self.navigationController.viewControllers = marr;
}

#pragma mark -
#pragma mark - 初始化子试图
- (void)setupSubviews
{
    [self addSubViews];   //增加子控件
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    UIButton* button = (UIButton *)sender;
    switch (button.tag) {
        case 100:   //开始直播
        {
            // 定义归档文件路径
            NSString *pathdata = [NSString stringWithFormat:@"%@/Documents/JDCloud_Live_Config",NSHomeDirectory()];
            // 解档
            ConfigPushFlowParamModel* configPushFlowParamModel;
            if ([[NSFileManager defaultManager] fileExistsAtPath:pathdata]) {
                configPushFlowParamModel = [NSKeyedUnarchiver unarchiveObjectWithFile:pathdata];
            }

            AppDelegate* app = (AppDelegate*)[UIApplication sharedApplication].delegate;
            if(app.floatPushStreamView == nil){
                if(configPushFlowParamModel.captureSource == 0){
                    JDStartPushFlowViewController* VC = [[JDStartPushFlowViewController alloc]init];
                    [VC resultConfigPushFlowParamModel:configPushFlowParamModel];
                    [self.navigationController pushViewController:VC animated:YES];
                }
                else{
                    UIPasteboard* pb = [UIPasteboard generalPasteboard];
                    pb.string = [configPushFlowParamModel toJsonString];
                    UIAlertView * alert = [[UIAlertView alloc] initWithTitle:@"京东视频云"
                                                                     message:@"请先到控制中心，长按启动屏幕录制"
                                                                    delegate:nil
                                                           cancelButtonTitle:@"确定"
                                                           otherButtonTitles:nil];
                    [alert show];
                }
            }
            else{
                [app.floatPushStreamView resumVC];
            }
        }
        break;
        case 101:   //返回首页
        {
            [self.navigationController popToRootViewControllerAnimated:YES];
        }
        break;
        default:
        break;
    }
}

//创建子试图
- (void)addSubViews
{
    UILabel* titleLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 107, ScreenWidth, 34)];
    titleLabel.textAlignment = NSTextAlignmentCenter;
    titleLabel.font = [UIFont systemFontOfSize:24 * SCALE_FONT];
    titleLabel.textColor = [UIColor whiteColor];
    titleLabel.text = @"直播已结束!";
    [self.view addSubview:titleLabel];
    
    UILabel* timeLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 166, ScreenWidth, 27)];
    timeLabel.textAlignment = NSTextAlignmentCenter;
    timeLabel.font = [UIFont systemFontOfSize:19 * SCALE_FONT];
    timeLabel.textColor = [JDStaticTools colorWithHexString:kJDVCThemeColor];
    timeLabel.text = self.resultDic[@"time"];
    [self.view addSubview:timeLabel];
    
    UILabel* subheadLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 201, ScreenWidth, 34)];
    subheadLabel.textAlignment = NSTextAlignmentCenter;
    subheadLabel.font = [UIFont systemFontOfSize:13 * SCALE_FONT];
    subheadLabel.textColor = [UIColor whiteColor];
    subheadLabel.text = @"本次直播时长";
    [self.view addSubview:subheadLabel];
    
    UIButton* _liveButton =  [UIButton buttonWithType:(UIButtonTypeCustom)];
    _liveButton.frame = CGRectMake(15, 275, ScreenWidth - 30, 44);
    [_liveButton setTitle:@"开始直播" forState:UIControlStateNormal];
    _liveButton.backgroundColor = [JDStaticTools colorWithHexString:kJDVCThemeColor];
    _liveButton.tag  = 100;
    _liveButton.layer.masksToBounds = YES;
    _liveButton.layer.cornerRadius = 10;
    _liveButton.titleLabel.font = [UIFont systemFontOfSize:17 * SCALE_FONT];
    [_liveButton setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [_liveButton addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:_liveButton];
    
    UIButton* _backButton =  [UIButton buttonWithType:(UIButtonTypeCustom)];
    _backButton.frame = CGRectMake(15, 340, ScreenWidth - 30, 44);
    [_backButton setTitle:@"返回首页" forState:UIControlStateNormal];
    _backButton.backgroundColor = RGBCOLOR(39, 47, 80);
    _backButton.tag  = 101;
    _backButton.layer.masksToBounds = YES;
    _backButton.layer.cornerRadius = 10;
    _backButton.titleLabel.font = [UIFont systemFontOfSize:17 * SCALE_FONT];
    [_backButton setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [_backButton addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:_backButton];
    
}
    
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
