//
//  JDPushFlowMainViewContoller.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/5.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDPushFlowMainViewContoller.h"
#import "PushFlowParamModel.h"
#import "ConfigPushFlowParamModel.h"
#import "PushFlowParamTableViewCell.h"
#import "JDPushFlowHighSetViewController.h"
#import "JDStartPushFlowViewController.h"
#import "JDScanViewController.h"
#import "AppDelegate.h"
#import "JDShowDocumentViewController.h"

@interface JDPushFlowMainViewContoller ()<UITableViewDelegate,UITableViewDataSource,UIGestureRecognizerDelegate>

@property (nonatomic, strong) UIImageView *bgImageV;             //背景图
@property (nonatomic, strong) UITableView *paramTableView;       //TableView
@property (nonatomic, strong) UIButton *liveButton;              //开始直播

@property (nonatomic, strong) NSMutableArray *dataTotalArr;      //tableView显示总共e的
@property (nonatomic, strong) NSMutableArray *dataArr;           //0:摄像头 1:录屏 显示不同cell

@property (nonatomic, strong) NSArray* collectionSourceArr;      //采集来源
@property (nonatomic, strong) NSArray* codeFormatArr;            //编码格式
@property (nonatomic, strong) NSArray* pictureQualityArr;        //画质
@property (nonatomic, strong) NSArray* performanceModeArr;       //性能模式
@property (nonatomic, strong) NSArray* liveScenceArr;            //直播场景

@property (nonatomic, strong) ConfigPushFlowParamModel *configPushFlowParamModel;    //直播推流参数model

@end

@implementation JDPushFlowMainViewContoller

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"推流工具";
    [self setupSubviews];
    [self setupParamData];
    [self segmentClickAction:0];//默认选择摄像头
    
    // 定义归档文件路径
    NSString *pathdata = [NSString stringWithFormat:@"%@/Documents/JDCloud_Live_Config",NSHomeDirectory()];
    // 解档
    if ([[NSFileManager defaultManager] fileExistsAtPath:pathdata]) {
        self.configPushFlowParamModel = [NSKeyedUnarchiver unarchiveObjectWithFile:pathdata];
        [self segmentClickAction:(int)self.configPushFlowParamModel.captureSource];
    }
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden = NO;
    
    // 刷新Cell
    [self reloadPushFlowParamModel];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
}

#pragma mark -
#pragma mark - 初始化子试图
//初始化子试图
- (void)setupSubviews
{
    [self addSubViews];   //增加子控件
    [self addGesture];    //增加手势
}

#pragma mark -
#pragma mark - 初始化model数据
- (void)setupParamData
{
    [self initConfigPushFlowParamModel];    //初始化推流的model
    [self initPushFlowParamModel];          //初始化cell的model
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    UIButton* button = (UIButton *)sender;
    switch (button.tag) {
        case 100:   //二维码
        {
            //1、判断相机权限是否打开
            AVAuthorizationStatus status = [AVCaptureDevice authorizationStatusForMediaType:AVMediaTypeVideo];
            if (status == AVAuthorizationStatusRestricted || status == AVAuthorizationStatusDenied)
            {
                // 无权限
                [[[JDActionController alloc]init] showAlertControllerWithTitle:@"“京东视频云”想访问您的相机" message:@"京东视频云需要访问你的相机权限，开启后才能扫描二维码" preferredStyle:UIAlertControllerStyleAlert otherButtonTitles:@[@"不允许",@"好"] superViewController:self actionControllerBlock:^(NSString *buttonTitle) {
                    if ([buttonTitle isEqualToString:@"好"]){
                        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:UIApplicationOpenSettingsURLString]];
                    }
                }];
                return;
            }
            
            JDScanViewController* VC = [[JDScanViewController alloc]init];
            VC.style = [JDScanViewController scanViewUIStyle];
            VC.succBlock = ^(NSString *scanResultStr) {
                self.configPushFlowParamModel.pushUrl = scanResultStr;
                [self reloadPushFlowParamModel];
            };
            [self.navigationController pushViewController:VC animated:YES];
        }
            break;
        case 101:   //高级设置
        {
            JDPushFlowHighSetViewController* VC = [[JDPushFlowHighSetViewController alloc]init];
            [VC resultConfigPushFlowParamModel:self.configPushFlowParamModel];
            [self.navigationController pushViewController:VC animated:YES];
        }
            break;
        case 102:   //开始直播
        {
            if(![self checkConfigValueIsReasonable]){
                return;
            }
            AppDelegate* app = (AppDelegate*)[UIApplication sharedApplication].delegate;
            if(app.floatPushStreamView == nil){
                if(self.configPushFlowParamModel.captureSource == 0){
                    JDStartPushFlowViewController* VC = [[JDStartPushFlowViewController alloc]init];
                    [VC resultConfigPushFlowParamModel:self.configPushFlowParamModel];
                    [self.navigationController pushViewController:VC animated:YES];
                }
                else{
                    if (@available(iOS 11.0, *)){
                        UIPasteboard* pb = [UIPasteboard generalPasteboard];
                        pb.string = [self.configPushFlowParamModel toJsonString];
                        UIAlertView * alert = [[UIAlertView alloc] initWithTitle:@"京东视频云"
                                                                         message:@"请先到控制中心，长按启动屏幕录制"
                                                                        delegate:nil
                                                               cancelButtonTitle:@"确定"
                                                               otherButtonTitles:nil];
                        [alert show];
                    }else{
                         [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"录屏功能只支持iOS11级以上，请升级后使用！"];
                    }
                }
            }
            else{
                [app.floatPushStreamView resumVC];
            }
        }
            break;
        case 103:   //查看文档
        {
            //去查看文档页面
            JDShowDocumentViewController* VC = [[JDShowDocumentViewController alloc]init];
            VC.title = @"录屏推流操作说明";
            [self.navigationController pushViewController:VC animated:YES];
        }
            break;
        default:
            break;
    }
}

#pragma mark -
#pragma mark - TableViewDataSources
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArr.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *cellIdentifier;
    if (self.dataArr.count >4) { //摄像头
        cellIdentifier = [NSString stringWithFormat:@"Camera%ld", (long)indexPath.row];
    }else{
        cellIdentifier = [NSString stringWithFormat:@"RecordScreen%ld", (long)indexPath.row];
    }
    
    PushFlowParamModel *model = self.dataArr[indexPath.row];
    PushFlowParamTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (!cell) {
        cell = [[PushFlowParamTableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier];
    }
    [cell configureCellModel:model withHight:44 from:@"JDPushFlowMainViewContoller"];
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
     return 44;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

#pragma mark -
#pragma mark - 功能函数
- (void)addSubViews {
    //TableView
    self.paramTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight-44)];
    self.paramTableView.delegate = self;
    self.paramTableView.dataSource = self;
    self.paramTableView.separatorStyle = NO;
    self.paramTableView.backgroundColor = [UIColor clearColor];
    [self.view addSubview:self.paramTableView];
    
    self.liveButton =  [UIButton buttonWithType:(UIButtonTypeCustom)];
    self.liveButton.frame = CGRectMake(0, ScreenHeight - 60 - SafeAreaBottomHeight, ScreenWidth, 60 + SafeAreaBottomHeight);
    [self.liveButton setTitleEdgeInsets:UIEdgeInsetsMake(0, 0, self.liveButton.titleLabel.frame.origin.y + SafeAreaBottomHeight, 0)];
    [self.liveButton setTitle:@"开始直播" forState:UIControlStateNormal];
    self.liveButton.backgroundColor = RGBCOLOR(39, 47, 80);
    self.liveButton.tag  = 102;
    self.liveButton.titleLabel.font = [UIFont systemFontOfSize:17 * SCALE_FONT];
    [self.liveButton setTitleColor:[UIColor whiteColor] forState:(UIControlStateNormal)];
    [self.liveButton addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    [self.view addSubview:self.liveButton];
    
    //高级设置
    UIButton* rightBtn = [JDStaticTools setNavigationRightItem:self title:@"高级设置" withFontSize:(13 * SCALE_FONT) textColor:[UIColor whiteColor] normalImageName:@"" hightLightedImageName:@""];
    [rightBtn sizeToFit];
    [rightBtn setFrame:CGRectMake(0, 0, 100, 35)];
    rightBtn.tag = 101;
    [rightBtn addTarget:self action:@selector(buttonClickAction:) forControlEvents:UIControlEventTouchUpInside];
}


//初始化推流model
- (void)initConfigPushFlowParamModel{
    
    /* * configPushFlowParamModel 初始化推流需要的数据* */
    if(!self.configPushFlowParamModel){
        self.configPushFlowParamModel = [[ConfigPushFlowParamModel alloc] init];
    }
    self.configPushFlowParamModel.pushUrl = [self generateDefaultPushUrl];
    self.configPushFlowParamModel.captureSource = 0;        //摄像头
    self.configPushFlowParamModel.videoCodecFormat = 0;     
    self.configPushFlowParamModel.pictureQuality = 1;       //540P
    self.configPushFlowParamModel.performanceMode = 0;
    self.configPushFlowParamModel.liveScence = 0;
    //高级设置
    self.configPushFlowParamModel.streamResolution = 1;     //540P
    self.configPushFlowParamModel.captureResolution = 2;    //720P
    self.configPushFlowParamModel.previewResolution = 2;    //720P
    self.configPushFlowParamModel.bitrateType = Bitrate_1000kbps;      //1000kb
    self.configPushFlowParamModel.bitrateAdjustMode = 1;    //动态码率
    self.configPushFlowParamModel.fpsStr = @"15";
    self.configPushFlowParamModel.keyInterval = KeyInterval_3s;
    self.configPushFlowParamModel.videoCodecType = 0;
    self.configPushFlowParamModel.audioSampleRate = SampleRate_44100;
    self.configPushFlowParamModel.audioBitrateStr = @"32";
    self.configPushFlowParamModel.audioCodecType = JDLPushAudioEncoderMode_AAC_LC;
    self.configPushFlowParamModel.audioChannelMode = JDLPushAudioChannel_1;
    self.configPushFlowParamModel.deviceOrientationMode = 1;    //竖屏
    self.configPushFlowParamModel.cameraType = JDLPushCameraTypeFront;
    self.configPushFlowParamModel.isBackgroundPush = NO;       
    self.configPushFlowParamModel.reconnectIntervalStr = @"1000";
    self.configPushFlowParamModel.reconnectCountStr = @"3";
    self.configPushFlowParamModel.isPicAndPicPush = NO;   //画中画默认关闭
}

- (NSString*)generateDefaultPushUrl{
    
    NSDate *date = [NSDate date];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    formatter.dateFormat = @"MMddHHmmss";
    NSString *dateString = [formatter stringFromDate:date];
    
    NSString* pushUrl = [NSString stringWithFormat:@"%@%@", @"rtmp://pu2.jdcloud.com/ios/", dateString];
    return pushUrl;
}


//初始化Cell的model
- (void)initPushFlowParamModel{
    
    self.collectionSourceArr = @[@"摄像头",@"录屏"];
    self.codeFormatArr = @[@"H.264",@"H.265"];
    self.performanceModeArr = @[@"低功耗",@"均衡",@"高性能"];
    self.liveScenceArr = @[@"美女直播",@"风景直播",@"运动直播",@"自动识别"];

    //画质支持 是否支持1080p
    if ([JDLive isCanSetSessionPreset:AVCaptureSessionPreset1920x1080 withCameraPosition:AVCaptureDevicePositionFront]) {
        self.pictureQualityArr = @[@"360P",@"540P",@"720P",@"1080P"];
    }else{
        self.pictureQualityArr = @[@"360P",@"540P",@"720P"];
    }
 
    //创建Cell的模型
    PushFlowParamModel *pushFlowAddress = [[PushFlowParamModel alloc] init];
    pushFlowAddress.title = @"推流地址";
    pushFlowAddress.infoText = @"二维码";
    pushFlowAddress.placeHolder = self.configPushFlowParamModel.pushUrl;
    pushFlowAddress.image = [JDStaticTools imageWithColor:[UIColor redColor]];
    pushFlowAddress.reuseId = PushFlowParamModelReuseCellInputButton;
    pushFlowAddress.inputAndButtonBlock = ^(NSString *message,UIButton* sender){
        if (message.length > 1) {
            self.configPushFlowParamModel.pushUrl = message;
        }else{
            if (sender) {
                sender.tag = 100;
                [self buttonClickAction:sender];
            }
        }
    };
    
    PushFlowParamModel *collectionSource = [[PushFlowParamModel alloc] init];
    collectionSource.title = @"采集来源";
    collectionSource.segmentTitleArray = self.collectionSourceArr;
    collectionSource.defaultValue = self.configPushFlowParamModel.captureSource;
    collectionSource.reuseId = PushFlowParamModelReuseCellSegment;
    collectionSource.segmentBlock = ^(int value) {
        self.configPushFlowParamModel.captureSource = value;
        [self segmentClickAction:value];
    };
    
    PushFlowParamModel *codeFormat = [[PushFlowParamModel alloc] init];
    codeFormat.title = @"编码方式";
    codeFormat.segmentTitleArray = self.codeFormatArr;
    codeFormat.defaultValue =  self.configPushFlowParamModel.videoCodecFormat;
    codeFormat.reuseId = PushFlowParamModelReuseCellSegment;
    codeFormat.segmentBlock = ^(int value) {
        self.configPushFlowParamModel.videoCodecFormat = value;
    };
    
    PushFlowParamModel *pictureQuality = [[PushFlowParamModel alloc] init];
    pictureQuality.title = @"画质";
    pictureQuality.segmentTitleArray = self.pictureQualityArr;
    pictureQuality.defaultValue =  self.configPushFlowParamModel.pictureQuality;
    pictureQuality.reuseId = PushFlowParamModelReuseCellSegment;
    pictureQuality.segmentBlock = ^(int value) {
        self.configPushFlowParamModel.pictureQuality = value;
        
        self.configPushFlowParamModel.captureResolution = value;
        self.configPushFlowParamModel.previewResolution = value;
        self.configPushFlowParamModel.streamResolution = value;
    };
    
    PushFlowParamModel *performanceMode = [[PushFlowParamModel alloc] init];
    performanceMode.title = @"性能模式";
    performanceMode.segmentTitleArray = self.performanceModeArr;
    performanceMode.defaultValue =  self.configPushFlowParamModel.performanceMode;
    performanceMode.reuseId = PushFlowParamModelReuseCellSegment;
    performanceMode.segmentBlock = ^(int value) {
        self.configPushFlowParamModel.performanceMode = value;
    };
    
    PushFlowParamModel *liveScence = [[PushFlowParamModel alloc] init];
    liveScence.title = @"直播场景";
    liveScence.segmentTitleArray = self.liveScenceArr;
    liveScence.defaultValue = self.configPushFlowParamModel.liveScence;
    liveScence.reuseId = PushFlowParamModelReuseCellSegment;
    liveScence.segmentBlock = ^(int value) {
        self.configPushFlowParamModel.liveScence = value;
    };
    
    PushFlowParamModel* checkDocument = [[PushFlowParamModel alloc] init];
    checkDocument.infoText = @"查看操作文档";
    checkDocument.reuseId = PushFlowParamModelReuseCellButton;
    checkDocument.buttonBlock = ^(UIButton* sender) {
        sender.tag = 103;
        [self buttonClickAction:sender];
    };
    
    self.dataTotalArr = [NSMutableArray arrayWithObjects:pushFlowAddress,collectionSource,codeFormat,pictureQuality, performanceMode,liveScence,checkDocument,nil];
}

//当页面上cell发生变化时，更新页面cell显示
- (void)reloadPushFlowParamModel
{
    for (PushFlowParamModel *model in self.dataTotalArr) {
        if ([model.title isEqualToString:@"推流地址"]) {
            if (model.placeHolder.length >0) {
                model.placeHolder = @"";
            }
            model.placeHolder = self.configPushFlowParamModel.pushUrl;
        }
        else if ([model.title isEqualToString:@"采集来源"]) {
            model.defaultValue = self.configPushFlowParamModel.captureSource;
        }
        else if ([model.title isEqualToString:@"画质"]) {
            model.defaultValue = self.configPushFlowParamModel.pictureQuality;
        }
        else if ([model.title isEqualToString:@"编码方式"]) {
            model.defaultValue = self.configPushFlowParamModel.videoCodecFormat;
        }
        else if ([model.title isEqualToString:@"性能模式"]) {
            model.defaultValue = self.configPushFlowParamModel.performanceMode;
        }
        else if ([model.title isEqualToString:@"直播场景"]) {
            model.defaultValue = self.configPushFlowParamModel.liveScence;
        }else{}
    }
    
    [self.paramTableView reloadData];
}

//采集来源的点击事件切换时
- (void)segmentClickAction:(int)value
{
    //刷新表单
    if(value == 1) {
        self.dataArr = [NSMutableArray arrayWithArray:self.dataTotalArr];
        [self.dataArr removeObjectAtIndex:2];
        [self.dataArr removeObjectAtIndex:3];
        [self.dataArr removeObjectAtIndex:3];
    }else{
        self.dataArr = [NSMutableArray arrayWithArray:self.dataTotalArr];
        [self.dataArr removeLastObject];
    }
    [self reloadPushFlowParamModel];
}

//点击开始推流前校验
- (BOOL)checkConfigValueIsReasonable
{
    // 定义归档文件路径
    NSString *pathdata = [NSString stringWithFormat:@"%@/Documents/JDCloud_Live_Config",NSHomeDirectory()];
    // 调用对象的归档方法 保存偏好设置
    [NSKeyedArchiver archiveRootObject:self.configPushFlowParamModel toFile:pathdata];
    
    //1.校验推流地址
    NSURL* pushUrl = [NSURL URLWithString:self.configPushFlowParamModel.pushUrl];
    if(!pushUrl || pushUrl == nil){
        [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"推流地址有误，请仔细检查推流地址并重新填写。"];
        return NO;
    }
    //2.校验 采集分辨率 >= 推流分辨率
    if (self.configPushFlowParamModel.captureResolution < self.configPushFlowParamModel.streamResolution) {
        [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"高级设置中，推流分辨率应不大于采集分辨率"];
        return NO;
    }
    //3、编码方式选择AAC_LD时，单声道，码率只能64
    if (self.configPushFlowParamModel.audioCodecType == JDLPushAudioEncoderMode_AAC_LD && self.configPushFlowParamModel.audioChannelMode == JDLPushAudioChannel_1 && (![self.configPushFlowParamModel.audioBitrateStr isEqualToString:@"64"])) {
        [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"高级设置中，编码方式选择AAC_LD，声道为单声道时，音频码率只能选择64"];
        return NO;
    }
    //4、编码方式选择AAC_LD时，双声道，码率只能128
    if (self.configPushFlowParamModel.audioCodecType == JDLPushAudioEncoderMode_AAC_LD && self.configPushFlowParamModel.audioChannelMode == JDLPushAudioChannel_2 && (![self.configPushFlowParamModel.audioBitrateStr isEqualToString:@"128"])) {
        [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"高级设置中，编码方式选择AAC_LD，声道为双声道时，音频码率只能选择128"];
        return NO;
    }
    //5、判断相机权限是否打开
    AVAuthorizationStatus status = [AVCaptureDevice authorizationStatusForMediaType:AVMediaTypeVideo];
    if (status == AVAuthorizationStatusRestricted || status == AVAuthorizationStatusDenied)
    {
        // 无权限
        [[[JDActionController alloc]init] showAlertControllerWithTitle:@"“京东视频云”想访问您的相机" message:@"京东视频云需要访问你的相机权限，开启后才能开始直播" preferredStyle:UIAlertControllerStyleAlert otherButtonTitles:@[@"不允许",@"好"] superViewController:self actionControllerBlock:^(NSString *buttonTitle) {
            if ([buttonTitle isEqualToString:@"好"]){
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:UIApplicationOpenSettingsURLString]];
            }
        }];
        return NO;
    }
    return YES;
}




#pragma mark -
#pragma mark - 手势
- (void)addGesture{
    //点击手势时为了收键盘
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapGesture:)];
    tap.delegate = self;
    [self.paramTableView addGestureRecognizer:tap];
}

//手势点击事件
- (void)tapGesture:(UITapGestureRecognizer *)gesture{
    [self.paramTableView endEditing:YES];
}




/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
