//
//  RTCTokenTools.m
//  jdcloud_videotools
//
//  Created by xiongyong19 on 2021/8/5.
//  Copyright © 2021 pengdandan. All rights reserved.
//

#import "RTCTokenTools.h"
#import <CommonCrypto/CommonDigest.h>
#import <CommonCrypto/CommonHMAC.h>


@implementation RTCTokenTools

+(NSString*)getTokenWithRoomId:(NSString*)roomId
                         appId:(NSString*)appId
                        appKey:(NSString*)appKey
                     timestamp:(long)timestamp
                        userId:(NSString*)userId
                         nonce:(NSString*)nonce
{
    NSString*json = [NSString stringWithFormat:@"{\"appId\":\"%@\",\"appKey\":\"%@\",\"roomId\":\"%@\",\"timestamp\":%ld,\"userId\":\"%@\"}",appId,appKey,roomId,timestamp,userId];
    NSData* originData = [RTCTokenTools hmac:json withKey:nonce];
    NSString* encodeResult = [originData base64EncodedStringWithOptions:0];
    NSData* originData2 = [encodeResult dataUsingEncoding:NSUTF8StringEncoding];
    NSString* encodeResult2 = [originData2 base64EncodedStringWithOptions:0];
    
    encodeResult2 = [encodeResult2 stringByReplacingOccurrencesOfString:@"+" withString:@"*"];
    encodeResult2 = [encodeResult2 stringByReplacingOccurrencesOfString:@"/" withString:@"-"];
    encodeResult2 = [encodeResult2 stringByReplacingOccurrencesOfString:@"=" withString:@"_"];
    
    return encodeResult;
}

+(NSData *)hmac:(NSString *)plaintext withKey:(NSString *)key
{
    const char *cKey  = [key cStringUsingEncoding:NSUTF8StringEncoding];
    const char *cData = [plaintext cStringUsingEncoding:NSUTF8StringEncoding];
    unsigned char cHMAC[CC_SHA256_DIGEST_LENGTH];
    CCHmac(kCCHmacAlgSHA256, cKey, strlen(cKey), cData, strlen(cData), cHMAC);
    NSData *HMACData = [NSData dataWithBytes:cHMAC length:sizeof(cHMAC)];
    return HMACData;
}
@end
