//
//  ConfigPushFlowParamModel.h
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/18.
//  Copyright © 2018年 pengdandan. All rights reserved.
//  开始直播上送字段

#import <Foundation/Foundation.h>

//码率枚举
typedef enum : NSUInteger {
    Bitrate_1000kbps,
    Bitrate_800kbps,
    Bitrate_600kbps,
    Bitrate_400kbps
} BitrateType;

//关键帧时间间隔枚举
typedef enum : NSUInteger {
    KeyInterval_1s,
    KeyInterval_2s,
    KeyInterval_3s,
    KeyInterval_4s,
    KeyInterval_5s,
} KeyIntervalType;

//音频采样率枚举
typedef enum : NSUInteger {
    SampleRate_32000,
    SampleRate_44100,
    SampleRate_48000,
} AudioSampleRateType;


@interface ConfigPushFlowParamModel : NSObject<NSCopying>

@property (nonatomic, strong) NSString* pushUrl;                        //推流地址

//简单设置
@property (nonatomic, assign) NSInteger captureSource;                  //采集来源
@property (nonatomic, assign) NSInteger videoCodecFormat;               //编码格式，无用
@property (nonatomic, assign) NSInteger pictureQuality;                 //画质
@property (nonatomic, assign) NSInteger performanceMode;                //性能模式，无用
@property (nonatomic, assign) NSInteger liveScence;                     //直播场景，无用

//高级设置
@property (nonatomic, assign) JDLPushResolution streamResolution;       //推流分辨率
@property (nonatomic, assign) JDLPushResolution captureResolution;      //采集分辨率
@property (nonatomic, assign) JDLPushResolution previewResolution;      //预览分辨率
@property (nonatomic, assign) BitrateType bitrateType;                  //码率
@property (nonatomic, assign) NSInteger bitrateAdjustMode;              //码率调节
@property (nonatomic, strong) NSString* fpsStr;                         //帧率
@property (nonatomic, assign) KeyIntervalType keyInterval;              //关键帧，单位秒
@property (nonatomic, assign) NSInteger videoCodecType;                 //编码方式
@property (nonatomic, assign) NSInteger audioSampleRate;                //音频采样率
@property (nonatomic, strong) NSString* audioBitrateStr;                //音频码率
@property (nonatomic, assign) JDLPushAudioEncoderMode audioCodecType;   //音频编码方式
@property (nonatomic, assign) JDLPushAudioChannel audioChannelMode;     //声道
@property (nonatomic, assign) int deviceOrientationMode;                //屏幕方向, 0:横屏；1：竖屏；2：动态
@property (nonatomic, assign) JDLPushCameraType cameraType;             //摄像头模式
@property (nonatomic, assign) BOOL isBackgroundPush;                    //是否后台推流，底层没有实现NO的情况
@property (nonatomic, strong) NSString* reconnectIntervalStr;           //重连时长
@property (nonatomic, strong) NSString* reconnectCountStr;              //重连次数
@property (nonatomic, assign) BOOL isPicAndPicPush;                     //是否画中画推流

    
- (NSString*)toJsonString;

@end
