//
//  ConfigPushFlowParamModel.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/18.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "ConfigPushFlowParamModel.h"
#import "JDStaticTools.h"
#import <objc/runtime.h>

@implementation ConfigPushFlowParamModel

- (void)dealloc
{
    
}

- (NSString*)toJsonString
{
    NSDictionary* dic = @{@"appid":@"com.jdcloud.jdcloud-ios-live-demo",
                          @"live_config":@{
                                  @"pushUrl":_pushUrl,
                                  @"videoCodecFormat":[NSNumber numberWithInt:(int)_videoCodecFormat],
                                  @"pictureQuality":[NSNumber numberWithInt:(int)_pictureQuality],
                                  @"streamResolution":[NSNumber numberWithInt:_streamResolution],
                                  @"bitrateType":[NSNumber numberWithInt:_bitrateType],
                                  @"bitrateAdjustMode":[NSNumber numberWithInt:(int)_bitrateAdjustMode],
                                  @"fpsStr":_fpsStr,
                                  @"keyInterval":[NSNumber numberWithInt:_keyInterval],
                                  @"videoCodecType":[NSNumber numberWithInt:(int)_videoCodecType],
                                  @"audioSampleRate":[NSNumber numberWithInt:(int)_audioSampleRate],
                                  @"audioBitrateStr":_audioBitrateStr,
                                  @"audioCodecType":[NSNumber numberWithInt:_audioCodecType],
                                  @"audioChannelMode":[NSNumber numberWithInt:_audioChannelMode],
                                  @"deviceOrientationMode":[NSNumber numberWithInt:_deviceOrientationMode],
                                  @"reconnectIntervalStr":_reconnectIntervalStr,
                                  @"reconnectCountStr":_reconnectCountStr
                        }
                          };
    
    return [JDStaticTools dictionary2JsonString:dic];
}

- (instancetype)copyWithZone:(NSZone *)zone
{
    ConfigPushFlowParamModel * copyedModel = [[[self class] allocWithZone:zone] init];
    copyedModel.pushUrl = self.pushUrl;
    copyedModel.captureSource = self.captureSource;
    copyedModel.videoCodecFormat = self.videoCodecFormat;
    copyedModel.pictureQuality =  self.pictureQuality;
    copyedModel.performanceMode = self.performanceMode;
    copyedModel.liveScence = self.liveScence;
    copyedModel.bitrateAdjustMode = self.bitrateAdjustMode;
    copyedModel.fpsStr = self.fpsStr;
    copyedModel.videoCodecType = self.videoCodecType;
    copyedModel.audioSampleRate = self.audioSampleRate;
    copyedModel.audioBitrateStr = self.audioBitrateStr;
    copyedModel.deviceOrientationMode = self.deviceOrientationMode;
    copyedModel.isBackgroundPush = self.isBackgroundPush;
    copyedModel.reconnectIntervalStr = self.reconnectIntervalStr;
    copyedModel.reconnectCountStr = self.reconnectCountStr;
    copyedModel.streamResolution = self.streamResolution;
    copyedModel.captureResolution = self.captureResolution;
    copyedModel.previewResolution = self.previewResolution;
    copyedModel.bitrateType = self.bitrateType;
    copyedModel.keyInterval = self.keyInterval;
    copyedModel.audioCodecType = self.audioCodecType;
    copyedModel.audioChannelMode = self.audioChannelMode;
    copyedModel.cameraType = self.cameraType;
    copyedModel.isPicAndPicPush = self.isPicAndPicPush;
    
    return copyedModel;
}

//归档
- (void)encodeWithCoder:(NSCoder *)aCoder{
    [aCoder encodeObject:self.pushUrl forKey:@"pushUrl"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.captureSource] forKey:@"captureSource"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.videoCodecFormat] forKey:@"videoCodecFormat"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.pictureQuality] forKey:@"pictureQuality"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.performanceMode] forKey:@"performanceMode"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.liveScence] forKey:@"liveScence"];
    
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.streamResolution] forKey:@"streamResolution"];

    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.captureResolution] forKey:@"captureResolution"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.previewResolution] forKey:@"previewResolution"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.bitrateType] forKey:@"bitrateType"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.bitrateAdjustMode] forKey:@"bitrateAdjustMode"];
    [aCoder encodeObject:self.fpsStr forKey:@"fpsStr"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.keyInterval] forKey:@"keyInterval"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.videoCodecType] forKey:@"videoCodecType"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.audioSampleRate] forKey:@"audioSampleRate"];
    [aCoder encodeObject:self.audioBitrateStr forKey:@"audioBitrateStr"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.audioCodecType] forKey:@"audioCodecType"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.audioChannelMode] forKey:@"audioChannelMode"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%d",self.deviceOrientationMode] forKey:@"deviceOrientationMode"];
    [aCoder encodeObject:[NSString stringWithFormat:@"%ld",self.cameraType] forKey:@"cameraType"];
    [aCoder encodeObject:self.reconnectIntervalStr forKey:@"reconnectIntervalStr"];
    [aCoder encodeObject:self.reconnectCountStr forKey:@"reconnectCountStr"];
    
    
    if(self.isBackgroundPush){
        [aCoder encodeObject:@"YES" forKey:@"isBackgroundPush"];
    }else{
        [aCoder encodeObject:@"NO" forKey:@"isBackgroundPush"];
    }
    
    if(self.isPicAndPicPush){
        [aCoder encodeObject:@"YES" forKey:@"isPicAndPicPush"];
    }else{
        [aCoder encodeObject:@"NO" forKey:@"isPicAndPicPush"];
    }
}

//解档
- (nullable instancetype)initWithCoder:(NSCoder *)aDecoder{
    self = [super init];
    if (self) {
        self.pushUrl = [aDecoder decodeObjectForKey:@"pushUrl"];
        self.captureSource = [[aDecoder decodeObjectForKey:@"captureSource"] integerValue];
        self.videoCodecFormat = [[aDecoder decodeObjectForKey:@"videoCodecFormat"] integerValue];
        self.pictureQuality =  [[aDecoder decodeObjectForKey:@"pictureQuality"] integerValue];
        self.performanceMode = [[aDecoder decodeObjectForKey:@"performanceMode"] integerValue];
        self.liveScence = [[aDecoder decodeObjectForKey:@"liveScence"] integerValue];
        self.bitrateAdjustMode = [[aDecoder decodeObjectForKey:@"bitrateAdjustMode"] integerValue];
        self.fpsStr = [aDecoder decodeObjectForKey:@"fpsStr"];
        self.videoCodecType = [[aDecoder decodeObjectForKey:@"videoCodecType"] integerValue];
        self.audioSampleRate = [[aDecoder decodeObjectForKey:@"audioSampleRate"] integerValue];
        self.audioBitrateStr = [aDecoder decodeObjectForKey:@"audioBitrateStr"];
        self.deviceOrientationMode = [[aDecoder decodeObjectForKey:@"deviceOrientationMode"] intValue];
        self.isBackgroundPush = [[aDecoder decodeObjectForKey:@"isBackgroundPush"] boolValue];
        self.reconnectIntervalStr = [aDecoder decodeObjectForKey:@"reconnectIntervalStr"];
        self.reconnectCountStr = [aDecoder decodeObjectForKey:@"reconnectCountStr"];
        
        self.streamResolution = (JDLPushResolution)[[aDecoder decodeObjectForKey:@"streamResolution"] integerValue];
        self.captureResolution = (JDLPushResolution)[[aDecoder decodeObjectForKey:@"captureResolution"] integerValue];
        self.previewResolution = (JDLPushResolution)[[aDecoder decodeObjectForKey:@"previewResolution"] integerValue];
        self.bitrateType = (BitrateType)[[aDecoder decodeObjectForKey:@"bitrateType"] integerValue];
        self.keyInterval = (KeyIntervalType)[[aDecoder decodeObjectForKey:@"keyInterval"] integerValue];
        self.audioCodecType = (JDLPushAudioEncoderMode)[[aDecoder decodeObjectForKey:@"audioCodecType"]  integerValue];
        self.audioChannelMode = (JDLPushAudioChannel)[[aDecoder decodeObjectForKey:@"audioChannelMode"]  integerValue];
        self.cameraType = (JDLPushCameraType)[[aDecoder decodeObjectForKey:@"cameraType"] integerValue];
        self.isPicAndPicPush = [[aDecoder decodeObjectForKey:@"isPicAndPicPush"] boolValue];
        
    }
    return self;
}




@end
