//
//  BrushControlView.m
//  jdcloud_ios_live_demo
//
//  Created by 杜治全 on 2018/11/27.
//  Copyright © 2018 pengdandan. All rights reserved.
//

#import "BrushControlView.h"

@interface BrushControlView()

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@end

@implementation BrushControlView

- (instancetype)initWithContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight)];
    if (self) {
        self.context = context;
        [self setupSubviews];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子视图
- (void)setupSubviews
{
    //背景色
    self.backgroundColor = [UIColor clearColor];
    
    [self addSubViews];
}

//子试图
- (void)addSubViews
{
    //清除
    UIButton* clearBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [clearBtn setFrame:CGRectMake(100, 0, 100, 50)];
    clearBtn.userInteractionEnabled = YES;
    //clearBtn.backgroundColor = RGBACOLOR(0, 0, 0, 0.1);
    [clearBtn setTitle:@"清除" forState:UIControlStateNormal];
    [clearBtn addTarget:self action:@selector(clear) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:clearBtn];
    
    //返回
    UIButton* backBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [backBtn setFrame:CGRectMake(200, 0, 100, 50)];
    backBtn.userInteractionEnabled = YES;
    //backBtn.backgroundColor = RGBACOLOR(0, 0, 0, 0.1);
    [backBtn setTitle:@"返回" forState:UIControlStateNormal];
    [backBtn addTarget:self action:@selector(backAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:backBtn];
}

#pragma mark -
#pragma mark - 返回视频推流

- (void)backAction
{
    [self.context.live resumeNormalPushStream];
    
    [[NSNotificationCenter defaultCenter] postNotificationName:@"JDLBrushViewBackNotification" object:nil];
}

- (void)clear
{
    [[NSNotificationCenter defaultCenter] postNotificationName:@"JDLClearPathNotification" object:nil];
}

@end
