//
//  BrushView.m
//  jdcloud_ios_live_demo
//
//  Created by 杜治全 on 2018/11/27.
//  Copyright © 2018 pengdandan. All rights reserved.
//

#import "BrushView.h"

@interface BrushView ()

@property (nonatomic, strong) UIBezierPath *path;

@end

@implementation BrushView

- (id)init
{
    self = [super init];
    self.path = [[UIBezierPath alloc] init];

    //[self awakeFromNib];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(clear) name:@"JDLClearPathNotification" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(clear) name:@"JDLBrushViewBackNotification" object:nil];

    return self;
}

- (void)dealloc
{
    [self clear];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"JDLClearPathNotification" object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:@"JDLBrushViewBackNotification" object:nil];
}

- (void)awakeFromNib
{
    [super awakeFromNib];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    CGPoint point = [[touches anyObject] locationInView:self];
    [self.path moveToPoint:point];
    [self setNeedsDisplay];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    CGPoint point = [[touches anyObject] locationInView:self];
    CGSize sz = self.frame.size;
    if ((point.y > 0) && (point.y < sz.height - 1))
    {
        [self.path addLineToPoint:point];
    }
    
    [self setNeedsDisplay];
}

- (void)touchesEnded:(NSSet<UITouch *> *)touches withEvent:(nullable UIEvent *)event
{

}

- (void)drawRect:(CGRect)rect
{
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    CGContextClearRect(ctx, rect);
    
    CGContextSetFillColorWithColor(ctx, [UIColor clearColor].CGColor);
    CGContextSetStrokeColorWithColor(ctx, [UIColor redColor].CGColor);
    CGContextSetLineWidth(ctx, 5.0);
    CGContextSetLineJoin(ctx, kCGLineJoinRound);
    CGContextSetLineCap(ctx, kCGLineCapRound);
    
    CGPathRef path =  self.path.CGPath;
    CGContextAddPath(ctx, path);
    CGContextStrokePath(ctx);
}

- (void)clear
{
    [self.path removeAllPoints];
    [self setNeedsDisplay];
}

@end
