//
//  OnlyAudioPushStreamView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/12.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "OnlyAudioPushStreamView.h"

@interface OnlyAudioPushStreamView()

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@end

@implementation OnlyAudioPushStreamView

- (instancetype)initWithContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight)];
    if (self) {
        self.context = context;
        [self setupSubviews];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子视图
- (void)setupSubviews
{
    //背景色
    self.backgroundColor = [UIColor clearColor];
    
    [self addSubViews];
}

//子试图
- (void)addSubViews
{
    //title
    UILabel* label = [[UILabel alloc]initWithFrame:CGRectMake(0, 200, ScreenWidth, 21)];
    label.textAlignment = NSTextAlignmentCenter;
    label.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    label.textColor = [UIColor whiteColor];
    label.text = @"纯音频推流中...";
    [self addSubview:label];
    
    //返回
    UIButton* leftBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [leftBtn setFrame:CGRectMake(15, 273/2+100, ScreenWidth - 30, 44)];
    leftBtn.userInteractionEnabled = YES;
    leftBtn.backgroundColor = RGBACOLOR(0, 0, 0, 0.1);
    [leftBtn setImage:[UIImage imageNamed:@"返回视频推流"] forState:UIControlStateNormal];
    [leftBtn setTitle:@"返回视频推流" forState:UIControlStateNormal];
    [leftBtn addTarget:self action:@selector(backAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:leftBtn];
}

#pragma mark -
#pragma mark - 返回视频推流

- (void)backAction
{
    [self.context.live resumeNormalPushStream];
    
}




@end
