//
//  PictureWaterMarkEditView.m
//  jdcloud_ios_live_demo
//
//  Created by 杜治全 on 2018/9/26.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "PictureWaterMarkEditView.h"

@implementation PictureWaterMarkEditView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    self.imageView = [[UIImageView alloc] init];
    [self.imageView setFrame:self.contentView.bounds];
    [self.imageView setImage:nil];
    [self.contentView addSubview:self.imageView];
    
//    UITapGestureRecognizer* singleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(onTap:)];
//    singleTap.numberOfTapsRequired = 1;
//    [_imageView addGestureRecognizer:singleTap];
    
    return self;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    
    self.imageView.frame = self.contentView.bounds;
}

- (void)setImageList:(NSArray<UIImage*>*) imageList duration:(CGFloat)duration
{
    if (imageList.count > 1)
    {
        _imageList = imageList;
        _duration = duration;
        
        _imageView.animationImages = imageList;
        _imageView.animationDuration = duration;
        [_imageView startAnimating];
    }
    else if (imageList.count > 0)
    {
        _imageList = nil;
        _imageView.animationImages = nil;
        _imageView.image = imageList[0];
    }
    else
    {
        _imageView.animationImages = nil;
        _imageView.animationDuration = 0;
        _imageView.image = nil;
    }
}

- (void)setAlpha:(CGFloat)alpha
{
    [_imageView setAlpha:alpha];
}

#pragma mark - GestureRecognizer handle
- (void)onTap:(UITapGestureRecognizer*)recognizer
{
    if (self.delegate && [self.delegate respondsToSelector:@selector(onEditViewComfirm:)])
    {
        [self.delegate onEditViewComfirm:self];
    }
}


@end
