//
//  TextWaterMarkEditView.m
//  jdcloud_ios_live_demo
//
//  Created by 杜治全 on 2018/9/26.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "TextWaterMarkEditView.h"

@implementation TextWaterMarkEditView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    self.textField = [[UITextField alloc] init];
    self.textField.placeholder = @"在这里输入文字";
    self.textField.textColor = [UIColor whiteColor];
    self.textField.textAlignment = NSTextAlignmentCenter;
    [self.contentView addSubview:self.textField];
    
    return self;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    
    CGRect rect = CGRectInset(self.contentView.bounds, 0, 0);
    [self.textField setFrame:rect];
}

- (void)setText:(NSString*)text
{
    [self.textField setText:text];
}

- (void)setTextColor:(UIColor*)color
{
    [self.textField setTextColor:color];
}

- (void)setTextFont:(UIFont*)font
{
    [self.textField setFont:font];
}

- (void)setAlpha:(CGFloat)alpha
{
    [self.textField setAlpha:alpha];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
