//
//  BeautifySetLevelView.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/10.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "BeautifySetLevelView.h"

@interface BeautifySetLevelView()
{
    
}

@property (nonatomic, strong) NSArray<UIButton *> *beautifyBtnArray;
@property (nonatomic, strong) UIButton *beautifyBtn;

@property (nonatomic, strong) NSArray<UIButton *> *filterBtnArray;
@property (nonatomic, strong) UIButton *filterBtn;

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@end

@implementation BeautifySetLevelView

- (instancetype)initWithContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super initWithFrame:CGRectMake(0, ScreenHeight - 140-80 - SafeAreaBottomHeight, ScreenWidth, 140+80 + SafeAreaBottomHeight)];
    if (self) {
        self.context = context;
        [self setupSubviews];
        
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子视图
- (void)setupSubviews
{
    self.backgroundColor = RGBACOLOR(0, 0, 0, 0.7);
    [self addSubViews];
    [self creatBeautifyButtons];
    [self creatFilterButtons];
    
}

//子试图
- (void)addSubViews
{
    {
        //title
        UILabel* label = [[UILabel alloc]initWithFrame:CGRectMake(0, 27, ScreenWidth, 21)];
        label.textAlignment = NSTextAlignmentCenter;
        label.font = [UIFont systemFontOfSize:15 * SCALE_FONT];
        label.textColor = [UIColor whiteColor];
        label.text = @"美颜";
        [self addSubview:label];
    }
    {
        //title
        UILabel* label = [[UILabel alloc]initWithFrame:CGRectMake(0, 27+80, ScreenWidth, 21)];
        label.textAlignment = NSTextAlignmentCenter;
        label.font = [UIFont systemFontOfSize:15 * SCALE_FONT];
        label.textColor = [UIColor whiteColor];
        label.text = @"滤镜";
        [self addSubview:label];
    }
    
    //返回
    UIButton* leftBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [leftBtn setFrame:CGRectMake(0, 16, 44, 44)];
    [leftBtn setBackgroundImage:[UIImage imageNamed:@"返回"] forState:UIControlStateNormal];
    [leftBtn setBackgroundImage:[UIImage imageNamed:@"返回"] forState:UIControlStateHighlighted];
    [leftBtn addTarget:self action:@selector(backAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:leftBtn];
    [leftBtn sizeToFit];
}

- (void)creatBeautifyButtons
{
   CGFloat buttonWidth = (ScreenWidth - 30)/6;
    int count = 6;
    NSMutableArray<UIButton *> *array = [NSMutableArray arrayWithCapacity:count];
    for (NSInteger index = 0; index < count; index++) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        button.frame = CGRectMake(15 + index * buttonWidth, 65, buttonWidth, 34);
        [button setTitle:@(index).stringValue forState:UIControlStateNormal];
        [button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [button setTitleColor:[JDStaticTools  colorWithHexString:kJDVCThemeColor] forState:UIControlStateSelected];
        button.backgroundColor = RGBACOLOR(0, 0, 0, 0.8);
        [button addTarget:self action:@selector(onBeautifyBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        button.tag = index;
        button.titleLabel.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
        
        [array addObject:button];
        [self addSubview:button];
    }
    self.beautifyBtnArray = array;
    
    int level = [_context.live getVideoBeautyWhiteLevel];
    self.beautifyBtn = self.beautifyBtnArray[level];
    self.beautifyBtn.selected = YES;
}

- (void)creatFilterButtons
{
    CGFloat buttonWidth = (ScreenWidth - 30)/6;
    int count = 6;
    NSMutableArray<UIButton *> *array = [NSMutableArray arrayWithCapacity:count];
    for (NSInteger index = 0; index < count; index++) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        button.frame = CGRectMake(15 + index * buttonWidth, 65+80, buttonWidth, 34);
        [button setTitle:@(index).stringValue forState:UIControlStateNormal];
        [button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [button setTitleColor:[JDStaticTools  colorWithHexString:kJDVCThemeColor] forState:UIControlStateSelected];
        button.backgroundColor = RGBACOLOR(0, 0, 0, 0.8);
        [button addTarget:self action:@selector(onFilterBtnClick:) forControlEvents:UIControlEventTouchUpInside];
        button.tag = index+100;
        button.titleLabel.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
        
        [array addObject:button];
        [self addSubview:button];
    }
    self.filterBtnArray = array;
    
    int index = [_context.live getVideoFilterEffectIndex];
    self.filterBtn = self.filterBtnArray[index];
    self.filterBtn.selected = YES;
}


#pragma mark -
#pragma mark - 点击事件
- (void)onBeautifyBtnClick:(UIButton *)sender
{
    self.beautifyBtn.selected = NO;
    self.beautifyBtn = sender;
    self.beautifyBtn.selected = YES;
    int level = (int)sender.tag;
    
    [_context.live setVideoBeautyWhiteLevel:level];
}

- (void)onFilterBtnClick:(UIButton *)sender
{
    self.filterBtn.selected = NO;
    self.filterBtn = sender;
    self.filterBtn.selected = YES;
    int index = (int)sender.tag-100;
    
    [_context.live setVideoFilterEffectIndex:index];
}

#pragma mark -
#pragma mark - 返回
- (void)backAction{
    [_context closeBottomPopupView];
}

@end
