//
//  NavigationItemTitleView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/9/26.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "NavigationItemTitleView.h"
#import "MoreSettingView.h"
#import "JDPushFlowMainViewContoller.h"
#import "JDTimeRuningView.h"
#import "JDLiveEndViewController.h"
#import "FloatPushStreamView.h"
#import "MBProgressHUD+Help.h"
#import "PlayerAddressView.h"

@interface NavigationItemTitleView()<UpdateTimerDelegate>
    
@property (nonatomic ,strong) UIImageView* redImageView;               //小红点
@property (nonatomic ,strong) UILabel* timeLabel;                      //时间Label
@property (nonatomic ,strong) UIButton* recordButton;                  //录制
    
@property (nonatomic ,strong) JDTimeRuningView* pushFlowTimeView;      //推流时间View
    
@property (nonatomic ,strong) JDTimeRuningView* recordTimeView;        //录制时间View
@property (nonatomic ,strong) NSString* recordFilePath;                //录制视频存放地址

@property (nonatomic ,strong) UIImageView* snapShotImageView;          //截屏ImageView

@property (nonatomic ,assign) BOOL  isBack;                            //返回按钮

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@end

@implementation NavigationItemTitleView

-(void)dealloc
{
    
}

- (instancetype)initWithContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super init];
    if (self) {
        self.isBack = NO;
        self.context = context;
        [self initNavgationcontrollerView];
        [self addNotifications];
        [self updateUIWithMediaRecordState:JDLMediaRecordState_Idle];
    }
    return self;
}

#pragma mark -
#pragma mark - 定制导航栏
- (void)initNavgationcontrollerView
{
    self.frame = CGRectMake(0, 0, ScreenWidth, 64 + SafeAreaNavHeight);
    self.backgroundColor = [JDStaticTools  colorWithHexString:kJDVCBackgroundColor];
    self.alpha = 0.7;
    //返回
    UIButton* _backButton = [self setupButtonWithFrame:CGRectMake(0, self.frame.size.height - 44, 44, 44) title:@"" normalImage:[UIImage imageNamed:@"返回"] selectImage:[UIImage imageNamed:@"返回"] bgColor:[UIColor clearColor] tag:100];
    [_backButton sizeToFit];
    [self addSubview:_backButton];

    //推流时间
    self.pushFlowTimeView = [[JDTimeRuningView alloc]initWithFrame:CGRectMake(40, (44 - 17)/2 + self.frame.size.height - 44, 100, 17) isHiddenRedPoint:NO textColor:[UIColor whiteColor]];
    self.pushFlowTimeView.delegate = self;
    [self addSubview:self.pushFlowTimeView];
    self.pushFlowTimeView.hidden = YES;

    CGFloat X = ScreenWidth - 3 - 34 * 5;    CGFloat width = 30;   CGFloat Y = self.frame.size.height - 37;   CGFloat height = 30;
    
    //截图
    UIButton* _screenshopButton = [self setupButtonWithFrame:CGRectMake(X, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"截图"] selectImage:[UIImage imageNamed:@"截图"] bgColor:[UIColor clearColor] tag:102];
    [_screenshopButton sizeToFit];
    [self addSubview:_screenshopButton];
    
    //录制
    self.recordButton = [self setupButtonWithFrame:CGRectMake(X + 34, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"录制"] selectImage:[UIImage imageNamed:@"摄像机_点击状态"] bgColor:[UIColor clearColor] tag:103];
    [_recordButton sizeToFit];
    [self addSubview:_recordButton];
    
    //闪光灯
    UIButton* _flashButton = [self setupButtonWithFrame:CGRectMake(X + 34 * 2, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"闪光灯"] selectImage:[UIImage imageNamed:@"闪光灯"] bgColor:[UIColor clearColor] tag:104];
    [_flashButton sizeToFit];
    [self addSubview:_flashButton];
    
    //相机
    UIButton* _cameraButton = [self setupButtonWithFrame:CGRectMake(X + 34 * 3, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"相机"] selectImage:[UIImage imageNamed:@"相机"] bgColor:[UIColor clearColor] tag:105];
    [_cameraButton sizeToFit];
    [self addSubview:_cameraButton];
    
    //更多
    UIButton* _moreButton = [self setupButtonWithFrame:CGRectMake(X + 34 * 4, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"更多"] selectImage:[UIImage imageNamed:@"更多"] bgColor:[UIColor clearColor] tag:106];
    [_moreButton sizeToFit];
    [self addSubview:_moreButton];
    
    //播放地址
    UIButton* _playAddressButton = [self setupButtonWithFrame:CGRectMake(X - 34, Y, width, height) title:@"" normalImage:[UIImage imageNamed:@"icon_QR"] selectImage:[UIImage imageNamed:@"icon_QR"] bgColor:[UIColor clearColor] tag:107];
    [_playAddressButton sizeToFit];
    [self addSubview:_playAddressButton];
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    UIButton* button = (UIButton *)sender;
    switch (button.tag) {
        case 100:   //返回
        {
            //是否悬浮窗
            if(self.context.isNeedFloatPush){
                FloatPushStreamView* floatView = [[FloatPushStreamView alloc] initWithContext:self.context];
                [floatView showInWindow];
            }
            else{
                if([self.context.live isPushStreaming]){
                    [[[JDActionController alloc]init] showAlertControllerWithTitle:@"结束直播" message:@"您正在推流是否结束？" preferredStyle:UIAlertControllerStyleAlert otherButtonTitles:@[@"取消",@"结束"] superViewController:(UIViewController*)self.context actionControllerBlock:^(NSString *buttonTitle) {
                        if ([buttonTitle isEqualToString:@"结束"]){
                            [self backAction];
                        }
                    }];
                    
                }else{
                    [self backAction];
                    
                }
            }
        }
            break;
        case 102:   //截图
        {
            JDLPushStreamState pushStatus = [_context.live getPushStreamState];
            if (pushStatus != JDLPushStreamState_Connected) {  //不再推流中，无法开启截图
                [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"请先开启推流,才能截屏哦~"];
            }
            else{  //在推流，可以截图
                
                //截屏
                [_context.live snapshotFromStreamWithCompletion:^(UIImage* img){
                    if (img) {
                        self.snapShotImageView = [[UIImageView alloc]initWithFrame:CGRectMake(50, 100, ScreenWidth - 100, img.size.height * (ScreenWidth - 100) / img.size.width)];
                        self.snapShotImageView.image = img;
                        UIWindow *window = [[UIApplication sharedApplication].windows lastObject];
                        [window addSubview:self.snapShotImageView];

                        //保存相册
                        UIImageWriteToSavedPhotosAlbum(img,nil,nil,nil);
                        //移除 imageView
                        [self performSelector:@selector(snapShotImageViewRemove) withObject:nil afterDelay:0.7];
                    }
                }];
            }
        }
            break;
        case 103:   //录制
        {
            JDLPushStreamState pushStatus = [_context.live getPushStreamState];
            if (pushStatus != JDLPushStreamState_Connected) {  //不再推流中，无法开启录制
                [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"请先开启推流,才能录制哦~"];
            }
            else{  //在推流，可以录制
                
                //录制的状态开始或者结束控制
                JDLMediaRecordState state = [_context.live getMediaRecordState];
                if(state != JDLMediaRecordState_Recording){
                    
                    NSString * dir = [NSHomeDirectory() stringByAppendingString:@"/Documents/"];
                    self.recordFilePath = [dir stringByAppendingPathComponent:@"video_record.mp4"];
                    
                    [_context.live startMediaRecord:[NSURL fileURLWithPath:self.recordFilePath]];
                }
                else{
                    [_context.live stopMediaRecord];
                }
            }
        }
            break;
        case 104:   //闪光灯
        {
            if([_context.live isFlashLightSupported]){
                [_context.live toggleFlashLight];
            }else{
                [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"后置摄像头时，闪光灯可用。"];
            }
        }
            break;
        case 105:   //相机
        {
            if ([_context.live isCaptureRunning]){
                [_context.live switchCamera];
            }
            
            if ([_context.live getCurrentDevicePosition] == AVCaptureDevicePositionFront) {
                 [_context.live setPushStreamHFlip:!_context.isMirroredPush];
            }else{
                 [_context.live setPushStreamHFlip:NO];
            }
        }
            break;
        case 106:   //更多
        {
            MoreSettingView* _moreSetView = [[MoreSettingView alloc] initWithContext:self.context];
            [_context showBottomPopupView:_moreSetView];
        }
            break;
        case 107:   //播放器地址
        {
            PlayerAddressView* _playerAddressView = [[PlayerAddressView alloc] initWithContext:self.context];
            [_context showBottomPopupView:_playerAddressView];
        }
            break;
        default:
            break;
    }
}

#pragma mark -
#pragma mark - 功能函数

//返回 销毁数据
- (void)backAction{
    self.isBack = YES;
    [self.recordTimeView removeFromSuperview];
    self.recordTimeView = nil;
    [self.recordTimeView stopTimer];
    [self.pushFlowTimeView stopTimer];
    [self.context popViewController];
    self.context.currentSelectAudioIndex = 0;
    
    //正在推流
    if([self.context.live isPushStreaming]){
        [self.context.live stopPushStream];
    }
    
    //预览暂停
    [self.context.live stopPreview];
}


//button初始化
- (UIButton *)setupButtonWithFrame:(CGRect)rect
                             title:(NSString*)title
                       normalImage:(UIImage *)normal
                       selectImage:(UIImage *)select
                           bgColor:(UIColor*)color
                               tag:(int)tag{
    
    UIButton *button = [UIButton buttonWithType:(UIButtonTypeCustom)];
    button.frame = rect;
    button.tag = tag;
    [button setBackgroundImage:normal forState:(UIControlStateNormal)];
    [button setBackgroundImage:select forState:(UIControlStateSelected)];
    [button setBackgroundColor:color];
    [button addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    return button;
}

- (void)snapShotImageViewRemove
{
    [UIView animateWithDuration:0.3 animations:^{
        [self.snapShotImageView removeFromSuperview];
        [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:@"截屏已保存相册哦~"];
    }];
}

#pragma mark -
#pragma mark - 通知
- (void)addNotifications
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLMediaRecordStateChangeNotification:) name:JDLMediaRecordStateChangeNotification object:nil];
     [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLPushStreamStateChangeNotification:) name:JDLPushStreamStateChangeNotification object:nil];
}

//录制状态通知
-(void)onJDLMediaRecordStateChangeNotification:(NSNotification *)notification
{
    JDLMediaRecordState state = [[notification object] intValue];
    [self updateUIWithMediaRecordState:state];
}

- (void)updateUIWithMediaRecordState:(JDLMediaRecordState)state
{
    switch (state) {
            // 初始状态
        case JDLMediaRecordState_Idle:
        case JDLMediaRecordState_Record_Error:
        {
            if(self.recordTimeView){
                [self.recordTimeView stopTimer];
                [self.recordTimeView removeFromSuperview];
                self.recordTimeView = nil;
            }
            _recordButton.selected = NO;
        }
            break;
            // 录像中
        case JDLMediaRecordState_Recording:
        {
            //录制的时间View出现或者消失控制
            if(!self.recordTimeView){
                self.recordTimeView = [[JDTimeRuningView alloc]initWithFrame:CGRectMake(ScreenWidth - 30*5, 0, 100, 17) isHiddenRedPoint:YES textColor:[JDStaticTools colorWithHexString:kJDVCThemeColor]];
                //window上有没有录制
                UIWindow *window = [UIApplication sharedApplication].keyWindow;
                for(UIView * view in [window subviews]){
                    if([view isKindOfClass:[JDTimeRuningView class]]){
                        [view removeFromSuperview];
                    }
                }
                //录制的时间加在window上了
                [window addSubview:self.recordTimeView];
                //设置位置
                CGRect selfFrame = [self convertRect:self.bounds toView:window]; //当前导航view相对于windowe的坐标
                self.recordTimeView.frame = CGRectMake(0, selfFrame.size.height + selfFrame.origin.y, 100, 17);
                self.recordTimeView.center = CGPointMake(self.recordButton.center.x, self.recordTimeView.center.y);
                self.recordTimeView.delegate = self;
                [self.recordTimeView startTimer:self.recordTimeView];
            }
            
            _recordButton.selected = YES;
        }
            break;
        case JDLMediaRecordState_Record_Stopped:
        {
            if (self.recordFilePath) {
                //保存视频到相册
                [self saveVideoToAlbum:self.recordFilePath];
            }

            if(self.recordTimeView){
                [self.recordTimeView stopTimer];
                [self.recordTimeView removeFromSuperview];
                self.recordTimeView = nil;
            }
            _recordButton.selected = NO;
        }
            break;
        default:
            break;
    }
}
    
//推流状态通知
- (void)onJDLPushStreamStateChangeNotification:(NSNotification *)notification
{
    JDLPushStreamState state = [[notification object] intValue];
    [self updateUIWithPushStreamState:state];
}
- (void)updateUIWithPushStreamState:(JDLPushStreamState)state
{
        switch (state) {
            // 初始化时状态为空闲
            case JDLPushStreamState_Idle:
            {
                self.pushFlowTimeView.hidden = YES;
            }
            break;
            // 连接中
            case JDLPushStreamState_Connecting:
            {
                
            }
            break;
            // 已连接
            case JDLPushStreamState_Connected:
            {
                self.pushFlowTimeView.hidden = NO;
               [self.pushFlowTimeView startTimer:self.pushFlowTimeView];
            }
            break;
            // 断开连接中
            case JDLPushStreamState_Stop:
            {
                [self.context.live stopBGMusicWithComplete:^(){}];
                
                //推流停止 定时器停止
                [self.pushFlowTimeView stopTimer];
                
                //点击返回，收到断开推流 不跳转结束页面
                if (self.isBack) {
                    return;
                }
                
                //推流时间
                NSMutableDictionary* dic = [NSMutableDictionary dictionary];
                [dic setValue:[self.pushFlowTimeView durationTime] forKey:@"time"];
                //去结束页面
                JDLiveEndViewController* VC = [[JDLiveEndViewController alloc]init];
                VC.resultDic = dic;
                [self.context pushViewController:VC];
            }
            break;
            // 推流出错
            case JDLPushStreamState_Error:
            {
                self.pushFlowTimeView.hidden = YES;
                [self.pushFlowTimeView stopTimer];
            }
            break;
            default:
            break;
    }
}

#pragma mark -
#pragma mark - UpdateTimerDelegate
- (void)updateTimeWith:(UIView*)editView
{
    if (editView == self.pushFlowTimeView) {
        
        //获取当前推流时长
        [self.pushFlowTimeView setTimeLabelText:-1];
    }
    else if (editView == self.recordTimeView){
        //获取当前录制时长
        NSInteger t = [_context.live getMediaRecordDuration];
        [self.recordTimeView setTimeLabelText:t];
    }
    else{}

}
    
//保存视频到相簿
- (void) saveVideoToAlbum: (NSString*) path {
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if (![fileManager fileExistsAtPath:path]) {
        return;
    }
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        if (UIVideoAtPathIsCompatibleWithSavedPhotosAlbum(path)) {
            SEL onDone = @selector(video:didFinishSavingWithError:contextInfo:);
            UISaveVideoAtPathToSavedPhotosAlbum(path, self, onDone, nil);
        }
    });
}
    
//保存mp4文件完成时的回调
- (void)video:(NSString *)videoPath didFinishSavingWithError:(NSError *)error
  contextInfo:(void *)contextInfo {
    NSString *message;
    if (!error) {
        message = @"Save album success!";
    }
    else {
        message = @"Failed to save the album!";
    }
    [MBProgressHUD showHUDInView:[UIApplication sharedApplication].keyWindow HudType:MBProgressHUDModeCustomView withText:message];
}



@end
