//
//  PlayerAddressView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/12/10.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "PlayerAddressView.h"
#import "JDQRCodeView.h"
#import "ConfigPushFlowParamModel.h"

@interface PlayerAddressView()

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@property (nonatomic, strong) JDQRCodeView *qrCodeView; //二维码生成view

@property (nonatomic, strong) ConfigPushFlowParamModel *configPushFlowParamModel;    //直播推流参数model

@property (nonatomic, copy) NSString *qrCodeString;

@property (nonatomic, assign) CGFloat labelHeight;

@end


@implementation PlayerAddressView

- (instancetype)initWithContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super initWithFrame:CGRectMake((ScreenWidth - 300)/2,(ScreenHeight - 400)/2 - 50, 300, 400)];
    if (self) {
        self.context = context;
        [self setupSubviews];
        
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子视图
- (void)setupSubviews
{
    self.backgroundColor = RGBACOLOR(0, 0, 0, 0.7);
    
    //返回
    UIButton* leftBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [leftBtn setFrame:CGRectMake(0, 13, 44, 44)];
    [leftBtn setBackgroundImage:[UIImage imageNamed:@"返回"] forState:UIControlStateNormal];
    [leftBtn setBackgroundImage:[UIImage imageNamed:@"返回"] forState:UIControlStateHighlighted];
    [leftBtn addTarget:self action:@selector(backAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:leftBtn];
    [leftBtn sizeToFit];

    // 定义归档文件路径
    NSString *pathdata = [NSString stringWithFormat:@"%@/Documents/JDCloud_Live_Config",NSHomeDirectory()];
    // 解档
    if ([[NSFileManager defaultManager] fileExistsAtPath:pathdata]) {
        if(!self.configPushFlowParamModel){
            self.configPushFlowParamModel = [[ConfigPushFlowParamModel alloc] init];
        }
        self.configPushFlowParamModel = [NSKeyedUnarchiver unarchiveObjectWithFile:pathdata];
        
        //获取推流地址 转播放地址
        NSString* pushURL = self.configPushFlowParamModel.pushUrl;
        if (pushURL.length > 10) {
            NSRange range = NSMakeRange(8, 1);
            self.qrCodeString = [pushURL stringByReplacingCharactersInRange:range withString:@"l"];
            [self addSubview:self.qrCodeView];
        }
    }

    //title
    UILabel* label = [[UILabel alloc]initWithFrame:CGRectMake(0, 60, 300, 100)];
    label.textAlignment = NSTextAlignmentCenter;
    label.font = [UIFont systemFontOfSize:15 * SCALE_FONT];
    label.numberOfLines = 5;
    label.textColor = [UIColor whiteColor];
    //赋值播放地址
    label.text = [NSString stringWithFormat:@"播放地址：%@",self.qrCodeString];
    [self addSubview:label];
    
}

- (JDQRCodeView *)qrCodeView{
    if (!_qrCodeView) {
        _qrCodeView = [[JDQRCodeView alloc] initWithFrame:CGRectMake((self.frame.size.width - 200)/2, (self.frame.size.height - 80 - 200)/2 + 100, 200, 200)];
        _qrCodeView.qrCodeString = self.qrCodeString;
    }
    return _qrCodeView;
}



#pragma mark -
#pragma mark - 返回
- (void)backAction{
    [_context closeBottomPopupView];
}


@end
