//
//  StartPushFlowView.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/7.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "StartPushFlowView.h"
#import "BeautifySetLevelView.h"
#import "OnlyAudioPushStreamView.h"
#import "BrushView.h"
#import "BrushControlView.h"
#import "JDMainChartView.h"
#import "LinkRoomTestViewController.h"
#import "AppDelegate.h"

@interface StartPushFlowView()

@property (nonatomic, assign) BOOL isAudioMute;           //是否静音
@property (nonatomic, strong) UIButton* muteButton;       //静音按钮
@property (nonatomic, strong) UIButton* startPushBtn;     //开始推流
@property (nonatomic, strong) UIButton* beautySetButton;  //美颜按钮
@property (nonatomic, strong) UIButton* brushButton;      //画笔按钮

@property (nonatomic, strong) UILabel* startPushTitleLab; //开始推流下面title
@property (nonatomic, strong) UILabel* pushErrorLab;      //推流错误提示

@property (nonatomic, strong) OnlyAudioPushStreamView* onlyAudioView;   //纯音频推流中View

@property (nonatomic, strong) BrushView* brushView;                     //画笔推流View
@property (nonatomic, assign) BOOL enableBrush;                         //是否启用画笔
@property (nonatomic, assign) int brushLayerId;                         //画笔图层号

@property (nonatomic, strong) JDMainChartView* chartMainView;           //统计折线图

@property (nonatomic, weak) id<JDPushFlowContextProtocol> context;

@end

@implementation StartPushFlowView

- (void)dealloc
{
    
}


- (instancetype)initWithFrame:(CGRect)frame withContext:(id<JDPushFlowContextProtocol>)context
{
    self = [super initWithFrame:frame];
    if (self) {
        self.context = context;
        [self setupSubviews];
        [self addNotifications];
        [self updateUIWithPushStream];
    }
    return self;
}

//其他子试图
- (void)setupSubviews
{
    CGFloat height = self.frame.size.height;
    
    //看折线图
    //[self addSubview:self.chartMainView];
    
    //连麦
    UIButton* linkRoomButton = [self setupButtonWithFrame:CGRectMake(ScreenWidth - 42 - 20, height - 166 - 42 -50, 42, 42) title:@"连麦" normalImage:[UIImage imageNamed:@""] selectImage:[UIImage imageNamed:@""] bgColor:[UIColor clearColor] tag:106];
    linkRoomButton.titleLabel.font = [UIFont systemFontOfSize:16.];
    [linkRoomButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self addSubview:linkRoomButton];
    
    //美颜
    self.beautySetButton = [self setupButtonWithFrame:CGRectMake(ScreenWidth - 42 - 20, height - 166 - 42, 42, 42) title:@"" normalImage:[UIImage imageNamed:@"美颜"] selectImage:[UIImage imageNamed:@"美颜"] bgColor:[UIColor clearColor] tag:107];
    [self addSubview:self.beautySetButton];
    
    //画笔
    self.brushButton = [self setupButtonWithFrame:CGRectMake(ScreenWidth - 42 - 20, height - 62 - 42 , 42, 42) title:@"" normalImage:[UIImage imageNamed:@"画笔"] selectImage:[UIImage imageNamed:@"画笔"] bgColor:[UIColor clearColor] tag:109];
    [self addSubview:self.brushButton];
    self.enableBrush = NO;
    self.brushLayerId = 0;
    
    //返回正常推流
    self.onlyAudioView = [[OnlyAudioPushStreamView alloc]initWithContext:self.context];
    [self addSubview:self.onlyAudioView];
    
    //静音
    self.muteButton = [self setupButtonWithFrame:CGRectMake(ScreenWidth - 42 - 20, height - 114 - 42 , 42, 42) title:@"" normalImage:[UIImage imageNamed:@"声音"] selectImage:[UIImage imageNamed:@"声音"] bgColor:[UIColor clearColor] tag:108];
    self.isAudioMute = NO;
    [self addSubview:self.muteButton];

    //开始推流
    self.startPushBtn = [self setupButtonWithFrame:CGRectMake((ScreenWidth-82)/2, height - 100 - 82 - SafeAreaBottomHeight, 82 , 82) title:@"" normalImage:[UIImage imageNamed:@"开始推流"] selectImage:[UIImage imageNamed:@"开始推流"] bgColor:[UIColor clearColor] tag:1000];
    [self addSubview:self.startPushBtn];
    
   // self.startPushTitleLab = [[UILabel alloc]initWithFrame:CGRectMake((ScreenWidth-82)/2, height - 65 - 21 - SafeAreaBottomHeight , 82, 21)];
    self.startPushTitleLab = [[UILabel alloc]initWithFrame:CGRectMake(0, height - 65 - 21 - SafeAreaBottomHeight , ScreenWidth, 21)];
    self.startPushTitleLab.textAlignment =  NSTextAlignmentCenter;
    self.startPushTitleLab.text = @"开始推流";
    self.startPushTitleLab.textColor = [UIColor whiteColor];
    self.startPushTitleLab.font = [UIFont systemFontOfSize:17 * SCALE_FONT];
    [self addSubview:self.startPushTitleLab];
    
    
    self.pushErrorLab = [[UILabel alloc]initWithFrame:CGRectMake(10, height + 30 - 65 - 21 - SafeAreaBottomHeight , ScreenWidth - 20, 21)];
    self.pushErrorLab.textColor = [UIColor lightGrayColor];
    self.pushErrorLab.textAlignment = NSTextAlignmentCenter;
    self.pushErrorLab.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    [self addSubview:self.pushErrorLab];
    
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    UIButton* button = (UIButton *)sender;
    switch (button.tag) {
        case 106:   //连麦
        {
            LinkRoomTestViewController* vc = [[LinkRoomTestViewController alloc] init];
            vc.context = _context;
            AppDelegate* app = (AppDelegate*)[UIApplication sharedApplication].delegate;
            [app.window.rootViewController presentViewController:vc animated:YES completion:^{
                
            }];
            
        }
            break;
        case 107:   //美颜
        {
            BeautifySetLevelView* _beautySetView  = [[BeautifySetLevelView alloc] initWithContext:self.context];
            [_context showBottomPopupView:_beautySetView];
        }
            break;
        case 108:   //静音
        {
            self.isAudioMute = !self.isAudioMute;
            if (self.isAudioMute) {
                [self.muteButton setBackgroundImage:[UIImage imageNamed:@"静音"] forState:UIControlStateNormal];
            }else{
                [self.muteButton setBackgroundImage:[UIImage imageNamed:@"声音"] forState:UIControlStateNormal];
            }
            [_context.live setAudioStreamMute:self.isAudioMute];
        }
            break;
        case 109:   //画笔
        {
            self.enableBrush = !self.enableBrush;

            if (self.enableBrush)
            {
                [self.brushButton setBackgroundImage:[UIImage imageNamed:@"画笔选中"] forState:UIControlStateNormal];

                self.brushView = [[BrushView alloc] init];
                [self.brushView setBackgroundColor:[UIColor clearColor]];
                [self.brushView setFrame:self.bounds];
                [self addSubview:self.brushView];
                [self sendSubviewToBack:self.brushView];
                
                self.brushLayerId = [_context.live addUIViewWithView:self.brushView rect:CGRectMake(0, 0, 1, 1) rotation:0 alpha:1 rotationMode:kJDLNoRotation];
            }
            else
            {
                [self.brushButton setBackgroundImage:[UIImage imageNamed:@"画笔"] forState:UIControlStateNormal];

                [_context.live removeLayerWithId:self.brushLayerId];
                self.brushLayerId = 0;
                [self.brushView removeFromSuperview];
            }

        }
            break;
        case 1000:  //开始推流
        {
            if ([JDStaticTools checkNetWork] > 0){
                 self.pushErrorLab.hidden = YES;
                //正在推流
                if(![_context.live isPushStreaming]){
                    [_context.live startPushStream];
                }
                else{
                    [_context.live stopPushStream];
                    if(_context.linkLive){
                        [_context.linkLive stopPK];
                    }
                }
                
            }else{
                self.pushErrorLab.hidden = NO;
                self.pushErrorLab.text = @"网络异常";
            }
            
        }
            break;
        default:
            break;
    }
}

//K线图
- (JDMainChartView *)chartMainView{
    if (!_chartMainView) {
        _chartMainView = [[JDMainChartView alloc]initWithFrame:self.frame];
    }
    return _chartMainView;
}

#pragma mark -
#pragma mark - 通知
- (void)addNotifications
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onAppDidEnterBackGround:) name:UIApplicationDidEnterBackgroundNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLPushStreamStateChangeNotification:) name:JDLPushStreamStateChangeNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLPushStreamModeChangeNotification:) name:JDLPushStreamModeChangeNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLPushStreamErrorNotification:) name:JDLPushStreamErrorNotification object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLBrushViewStartNotification:) name:@"JDLBrushViewStartNotification" object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(onJDLBrushViewBackNotification:) name:@"JDLBrushViewBackNotification" object:nil];

}

- (void)onAppDidEnterBackGround:(NSNotification *)notification
{
    [[UIApplication sharedApplication] beginBackgroundTaskWithExpirationHandler:^{
        
    }];
}

- (void)onJDLBrushViewStartNotification:(NSNotification *)notification
{
    [_context.live startUIViewPushStream:self.brushView];
}

- (void)onJDLBrushViewBackNotification:(NSNotification *)notification
{
    [_context.live resumeNormalPushStream];
}

- (void)onJDLPushStreamStateChangeNotification:(NSNotification *)notification
{
    [self updateUIWithPushStream];
}

- (void)onJDLPushStreamModeChangeNotification:(NSNotification *)notification
{
    [self updateUIWithPushStream];
}

- (void)updateUIWithPushStream
{
    //当前模式
    JDLPushStreamMode mode = [self.context.live getPushStreamMode];
    switch (mode) {
            //正常推流
        case JDLPushStreamMode_Normal:
        {
            [self updateUIWithPushStreamMode_Normal];
            [self updateUIWithPushStreamState];
        }
            break;
        //背景图推流
        case JDLPushStreamMode_Audio:
        {
            [self updateUIWithPushStreamMode_Audio];
            [self updateUIWithPushStreamState];
        }
            break;
        //背景图推流
        case JDLPushStreamMode_Image_Audio:
        {
            [self updateUIWithPushStreamMode_Image_Audio];
            [self updateUIWithPushStreamState];
        }
            break;
        //UIView推流
        case JDLPushStreamMode_UIView:
        {
            [self updateUIWithPushStreamMode_Brush];
            [self updateUIWithPushStreamState];
        }
            break;
        default:
            break;
    }
}

- (void)updateUIWithPushStreamMode_Normal
{
    self.onlyAudioView.hidden = YES;
    self.beautySetButton.hidden = NO;
    self.brushView.hidden = NO;
    self.brushButton.hidden = NO;
}

- (void)updateUIWithPushStreamMode_Audio
{
    self.onlyAudioView.hidden = NO;
    self.onlyAudioView.backgroundColor = [UIColor clearColor];//[JDStaticTools colorWithHexString:@"#4d4d4d"];
    self.beautySetButton.hidden = YES;
    self.brushView.hidden = YES;
    self.brushButton.hidden = YES;
}

- (void)updateUIWithPushStreamMode_Image_Audio
{
    self.onlyAudioView.hidden = NO;
    self.beautySetButton.hidden = YES;
    self.brushView.hidden = YES;
    self.brushButton.hidden = YES;
    self.onlyAudioView.backgroundColor = [UIColor clearColor];
}

- (void)updateUIWithPushStreamMode_Brush
{
    self.onlyAudioView.hidden = YES;
    self.beautySetButton.hidden = YES;
    self.brushView.hidden = NO;
    self.brushButton.hidden = NO;
}

- (void)updateUIWithPushStreamState
{
    //推流错误码label默认隐藏
    self.pushErrorLab.hidden = YES;
    
    //当前状态
    JDLPushStreamState state = [self.context.live getPushStreamState];
    //开始更新UI状态代码
    switch (state) {
            // 初始化时状态为空闲
        case JDLPushStreamState_Idle:
        {
            self.startPushTitleLab.text = @"开始推流";
            self.startPushBtn.enabled = YES;
            [self.startPushBtn setBackgroundImage:[UIImage imageNamed:@"开始推流"] forState:UIControlStateNormal];
        }
            break;
            // 连接中
        case JDLPushStreamState_Connecting:
        {
            self.startPushTitleLab.text = @"正在连接";
            self.startPushBtn.enabled = NO;
            [self.startPushBtn setBackgroundImage:[UIImage imageNamed:@"开始推流"] forState:UIControlStateNormal];
        }
            break;
            // 已连接
        case JDLPushStreamState_Connected:
        {
            self.startPushTitleLab.text = @"结束推流";
            self.startPushBtn.enabled = YES;
            [self.startPushBtn setBackgroundImage:[UIImage imageNamed:@"结束推流"] forState:UIControlStateNormal];
        }
            break;
            // 断开连接中
        case JDLPushStreamState_Stop:
        {
            self.startPushTitleLab.text = @"正在结束";
            self.startPushBtn.enabled = NO;
            [self.startPushBtn setBackgroundImage:[UIImage imageNamed:@"结束推流"] forState:UIControlStateNormal];
        }
            break;
            // 推流出错
        case JDLPushStreamState_Error:
        {
            self.startPushTitleLab.text = @"开始推流";
            self.startPushBtn.enabled = YES;
            [self.startPushBtn setBackgroundImage:[UIImage imageNamed:@"开始推流"] forState:UIControlStateNormal];
        }
            break;
        default:
            break;
    }
}

//推流错误显示
- (void)onJDLPushStreamErrorNotification:(NSNotification *)notification
{
    //推流错误label显示
    self.pushErrorLab.hidden = NO;
    
    JDLStreamErrorCode error = [[notification object] intValue];
    switch (error) {
            case JDLStreamErrorCode_AUTH_NO_INIT:
                self.pushErrorLab.text = @"SDK鉴权没有初始化";
                break;
            case JDLStreamErrorCode_AUTH_PARAM_INVALID:
                self.pushErrorLab.text = @"SDK鉴权参数不合法";
                break;
            case JDLStreamErrorCode_AUTH_FORBIDDEN:
                self.pushErrorLab.text = @"SDK被禁用";
                break;
            case JDLStreamErrorCode_AUTH_LIMITED:
                self.pushErrorLab.text = @"SDK权限受限";
                break;
            case JDLStreamErrorCode_AUTH_FORMAT_INVALID:
                self.pushErrorLab.text = @"SDK鉴权解析异常";
                break;
            case JDLStreamErrorCode_ALREADY_EXIST_STREAM_NAME:
                self.pushErrorLab.text = @"此流已存在";
                break;
            case JDLStreamErrorCode_SIGNATURE_NOT_MATCH:
                self.pushErrorLab.text = @"签名不匹配";
                break;
            case JDLStreamErrorCode_REFER_NOT_MATCH:
                self.pushErrorLab.text = @"refer鉴权失败";
                break;
            case JDLStreamErrorCode_FORBIDDEN:
                self.pushErrorLab.text = @"流被拒绝";
                break;
            case JDLStreamErrorCode_INVALID_ACCESS_KEY:
                self.pushErrorLab.text = @"无效的AccessKey";
                break;
            case JDLStreamErrorCode_MISS_ACCESS_KEY:
                self.pushErrorLab.text = @"缺少access key";
                break;
            case JDLStreamErrorCode_INTERNAL_ERROR:
                self.pushErrorLab.text = @"推流失败 未知原因";
                break;
            case JDLStreamErrorCode_DNS_PARSE_FAILED:
                self.pushErrorLab.text = @"DNS解析错误";
                break;
        default:
        {
            if ([JDStaticTools checkNetWork] < 1){
                self.pushErrorLab.text = @"网络异常";
            }else{
                self.pushErrorLab.text = @"推流失败";
            }
        }
        break;
    }
}


#pragma mark -
#pragma mark - 功能函数
//button初始化
- (UIButton *)setupButtonWithFrame:(CGRect)rect
                             title:(NSString*)title
                       normalImage:(UIImage *)normal
                       selectImage:(UIImage *)select
                           bgColor:(UIColor*)color
                               tag:(int)tag{
    
    UIButton *button = [UIButton buttonWithType:(UIButtonTypeCustom)];
    button.frame = rect;
    button.tag = tag;
    [button setTitle:title forState:(UIControlStateNormal)];
    [button setBackgroundImage:normal forState:(UIControlStateNormal)];
    [button setBackgroundImage:select forState:(UIControlStateSelected)];
    [button setBackgroundColor:color];
    button.titleLabel.font = [UIFont systemFontOfSize:13.];
    [button setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
    [button addTarget:self action:@selector(buttonClickAction:) forControlEvents:(UIControlEventTouchUpInside)];
    return button;
}




@end

