//
//  JDHomeViewController.m
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/5.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDHomeViewController.h"
#import "HomeModuleDefine.h"
#import "HomeModuleItemCell.h"
#import "JDPushFlowMainViewContoller.h"
#import "AppDelegate.h"
#import <Photos/PHFetchOptions.h>
#import <Photos/PHAsset.h>

#define screenProportion      ScreenWidth/350              //根据这个比例显示首页控件

@interface JDHomeViewController ()<UICollectionViewDataSource,UICollectionViewDelegate>

@property (strong, nonatomic) UILabel *JDTitleLabel;

@property (strong, nonatomic) UILabel *JDSubheadLabel;

@property (strong, nonatomic) NSMutableArray <HomeModuleDefine *>*dataArray;

@property (strong, nonatomic) UICollectionView *collectionView; //模块

@end

@implementation JDHomeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self configBaseUI];
    [self configBaseData];
}

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.hidden = YES;
    
}

#pragma mark -
#pragma mark - 初始化函数
//初始化UI
- (void)configBaseUI
{
    // 背景图
    UIImageView *bg = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, ScreenWidth, 211*screenProportion + SafeAreaTopHeight)];
    bg.image = [UIImage imageNamed:@"start_top"];
    [self.view addSubview:bg];
    
    //隐藏返回按钮
    [self initNavgationcontrollerLeftButton];
    [self.view addSubview:self.JDTitleLabel];
    [self.view addSubview:self.JDSubheadLabel];
    [self.view addSubview:self.collectionView];
    
//    //版本号
//    NSString* appVersion = [[NSBundle mainBundle] objectForInfoDictionaryKey:@"CFBundleShortVersionString"];
//    //取工程中txt
//    NSString *resourcePath = [[NSBundle mainBundle] pathForResource:@"appver" ofType:@"txt"];
//    NSString* content = [NSString stringWithContentsOfFile:resourcePath encoding:NSUTF8StringEncoding error:nil];
//    //显示版本号
//    UILabel* versionLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, ScreenHeight - 10 - SafeAreaTopHeight, ScreenWidth, 10)];
//    versionLabel.text = [NSString stringWithFormat:@"版本号：%@  build：%@",appVersion,content];
//    versionLabel.textColor = [JDStaticTools colorWithHexString:kJDVCThemeColor];
//    versionLabel.textAlignment = NSTextAlignmentCenter;
//    versionLabel.font = [UIFont systemFontOfSize:10];
//    [self.view addSubview:versionLabel];
}

#pragma mark - Lazy init
- (UILabel *)JDTitleLabel{
    if (!_JDTitleLabel) {
        _JDTitleLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 80*screenProportion + SafeAreaTopHeight, ScreenWidth, 30)];
        _JDTitleLabel.textAlignment = NSTextAlignmentCenter;
        _JDTitleLabel.font = [UIFont boldSystemFontOfSize:28 * SCALE_FONT];
        _JDTitleLabel.textColor = [UIColor whiteColor];
        _JDTitleLabel.text = @"京东云";
    }
    return _JDTitleLabel;
}

- (UILabel *)JDSubheadLabel{
    if (!_JDSubheadLabel) {
        _JDSubheadLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 140*screenProportion + SafeAreaTopHeight, ScreenWidth, 30)];
        _JDSubheadLabel.textAlignment = NSTextAlignmentCenter;
        _JDSubheadLabel.font = [UIFont systemFontOfSize:17 * SCALE_FONT];
        _JDSubheadLabel.textColor = [UIColor whiteColor];
        _JDSubheadLabel.text = @"引领无限未来";
    }
    return _JDSubheadLabel;
}

- (UICollectionView *)collectionView{
    if (!_collectionView) {
        UICollectionViewFlowLayout* flowLayout = [[UICollectionViewFlowLayout alloc]init];
        [flowLayout setScrollDirection:UICollectionViewScrollDirectionVertical];

        CGFloat y = 211*screenProportion + SafeAreaTopHeight;
        _collectionView = [[UICollectionView alloc]initWithFrame:CGRectMake(0, y, ScreenWidth, ScreenHeight - y - 30) collectionViewLayout:flowLayout];
        [_collectionView registerNib:[UINib nibWithNibName:@"HomeModuleItemCell" bundle:[NSBundle mainBundle]] forCellWithReuseIdentifier:@"HomeModuleItemCell"];
        _collectionView.dataSource = self;
        _collectionView.delegate = self;
        _collectionView.backgroundColor = [UIColor clearColor];
    }
    return _collectionView;
}

#pragma mark - BaseDataSet
//初始化基本数据
- (void)configBaseData{
    
    self.dataArray = [NSMutableArray array];
    for (int i = 1; i < 3; i ++) {
         HomeModuleDefine *module = [[HomeModuleDefine alloc]initWithModuleType:(JD_Live_ModuleType)i];
        [self.dataArray addObject:module];
    }
}

#pragma mark  定义每个UICollectionView的大小
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
   // CGFloat widthProportion = (ScreenHeight - (211*screenProportion + SafeAreaTopHeight))/456;
    CGFloat itemWidth = 156*screenProportion;
    if (screenProportion>1) {
        itemWidth = 156;
    }
    return  CGSizeMake(itemWidth,itemWidth);
}

#pragma mark  定义整个CollectionViewCell与整个View的间距
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    CGFloat itemWidth = 156*screenProportion;
    if (screenProportion>1) {
        itemWidth = 156;
    }
    return UIEdgeInsetsMake(30, (ScreenWidth - itemWidth)/2, 10, (ScreenWidth - itemWidth)/2);//（上、左、下、右）
}

#pragma mark  定义每个UICollectionView的纵向间距
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    return 30;
}

#pragma mark - UICollectionViewDataSource

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    HomeModuleItemCell* cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"HomeModuleItemCell" forIndexPath:indexPath];
    if (self.dataArray.count >indexPath.row) {
        HomeModuleDefine* define = self.dataArray[indexPath.row];
        [cell configWithModule:define];
    }
    return cell;
    
}

#pragma mark - UICollectionViewDelegate
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    AppDelegate* app = (AppDelegate*)[UIApplication sharedApplication].delegate;
    if (self.dataArray.count > indexPath.row) {
        HomeModuleDefine * module = self.dataArray[indexPath.row];
        switch (module.type) {
            case JD_Live_ModuleType_PushFlow:
            {
                [self getPhotoAuthorization];
                if (app.playerSmallWindow) {
                    [app.playerSmallWindow destroyPlayer];
                }
                [self pushTargetVCWithClassString:@"JDPushFlowMainViewContoller"];
            }
                break;
            case JD_Live_ModuleType_VideoPlay:
            {
                [self getPhotoAuthorization];
                if (app.floatPushStreamView) {
                    [app.floatPushStreamView closeWindow];
                }
                if(app.playerSmallWindow == nil){
                    [self pushTargetVCWithClassString:@"JDVideoPlayMainViewController"];
                }else{
                    [app.playerSmallWindow resumVC];
                }
            }
                break;
            default:
                break;
        }
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//支持旋转
- (BOOL)shouldAutorotate
{
    return YES;
}

//支持的方向
- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    return UIInterfaceOrientationMaskPortrait;
}

- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation
{
    return UIInterfaceOrientationPortrait;
}

- (void)getPhotoAuthorization
{
    PHFetchOptions *fetchOption = [[PHFetchOptions alloc] init];
    fetchOption.sortDescriptors = @[[NSSortDescriptor sortDescriptorWithKey:@"creationDate" ascending:false]];
    fetchOption.predicate = [NSPredicate predicateWithFormat:@"mediaType = %d",PHAssetMediaTypeVideo];
    PHFetchResult *fetchResults = [PHAsset fetchAssetsWithMediaType:PHAssetMediaTypeVideo options:fetchOption];
}
/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
