//
//  JDVideoPlayContextProtocol.h
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/4.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VideoPlayListModel.h"

@protocol JDVideoPlayContextProtocol <NSObject>

//播放器
@property (nonatomic, readonly) JDCloudPlayer *jdCloudPlayer;

//播放器中数据
@property (nonatomic, strong) VideoPlayListModel *infoModel;

//最后一次选择视频类型
@property (nonatomic, assign) JDCloudPlayerVideoListType lastSelecterVideoListType;

//最后一次选择视频的行
@property (nonatomic, assign) NSInteger lastSelecterVideoRow;

//显示底部弹出view
- (void)showBottomPopupView:(UIView*)bottomView;

//关闭底部弹出view
- (void)closeBottomPopupView;

//推下一个VC
- (void)pushViewController:(UIViewController*)VC;

//关闭VC
- (void)popViewController;

//临时隐藏VC
- (void)hideViewController;

//显示VC
- (void)showViewController;

//销毁VC
- (void)releaseViewController;

//设置播放信息
- (void)playWithPlayerInfoModel:(VideoPlayListModel *)infoModel;

//播放器时间回调，用于记录日志
- (void)playHappenEvent:(JDCloudPlayerEvent)event withPlayerInfo:(NSDictionary *)dict;

//下一集
- (void)videoPlayNextURL;

//获取点播视频下一集视频信息
- (VideoPlayListModel *)nextPlayInfoModel;

//展示loading框
- (void)showLoadingView;


@end

