//
//  JDCloudLogModel.h
//  jdcloud_ios_live_demo
//
//  Created by 王亚伟 on 2018/10/19.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@interface JDCloudPlayLogModel : NSObject

/**
 根据播放事件返回对应的事件描述
 
 @param event 播放事件
 @return 事件描述
 */
+ (NSString *)descriptionWithEvent:(JDCloudPlayerEvent)event;


/**
 Designated Initializer
 
 @param event 播放事件
 @return 用于显示的模型类
 */
- (instancetype)initWithEvent:(JDCloudPlayerEvent)event;

@property (strong, nonatomic, readonly) NSDate *happenDate;

@property (assign, nonatomic, readonly) JDCloudPlayerEvent event;


/**
 事件发生的时间的字符串 HH:mm:ss
 */
- (NSString *)timeString;

/**
 事件描述字符串
 
 @return 事件描述字符串
 */
- (NSString *)eventDescription;

@end

NS_ASSUME_NONNULL_END
