//
//  JDCloudLogModel.m
//  jdcloud_ios_live_demo
//
//  Created by 王亚伟 on 2018/10/19.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudPlayLogModel.h"

@implementation JDCloudPlayLogModel

+ (NSString *)descriptionWithEvent:(JDCloudPlayerEvent)event{
    NSString *eventString = @"";
    switch (event) {
        case JDCloudPlayerEventPrepareDone:
            eventString = @"准备成功";
            break;
        case JDCloudPlayerEventPlay:
            eventString = @"开始播放";
            break;
        case JDCloudPlayerEventFirstFrame:
            eventString = @"第一帧加载完成";
            break;
        case JDCloudPlayerEventPause:
            eventString = @"暂停播放";
            break;
        case JDCloudPlayerEventStop:
            eventString = @"停止播放";
            break;
        case JDCloudPlayerEventFinish:
            eventString = @"播放已结束";
            break;
        case JDCloudPlayerEventBeginLoading:
            eventString = @"开始加载视频数据";
            break;
        case JDCloudPlayerEventEndLoading:
            eventString = @"视频资源加载完成";
            break;
        case JDCloudPlayerEventSeekDone:
            eventString = @"跳转成功";
            break;
        case JDCloudPlayerEventInterrupted:
            eventString = @"播放被中断";
            break;
        case JDCloudPlayerEventSeekingForward:
            eventString = @"向前跳转";
            break;
        case JDCloudPlayerEventSeekingBackward:
            eventString = @"向后跳转";
            break;
        case JDCloudPlayerEventNaturalSizeChanged:
            eventString = @"获取到视频宽高";
            break;
        case JDCloudSeekVideoStart:
            eventString = @"跳转后视频开始渲染";
            break;
        case JDCloudSeekAudioStart:
            eventString = @"跳转后音频开始播放";
            break;
        default:
            break;
    }
    return eventString;
}

- (instancetype)initWithEvent:(JDCloudPlayerEvent)event{
    self = [super init];
    if (self) {
        _happenDate = [NSDate date];
        _event = event;
    }
    return self;
}

- (NSString *)timeString{
    NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
    [formatter setDateFormat:@"HH:mm:ss.SSS"];
    NSString *timeString = [formatter stringFromDate:self.happenDate];
    return timeString;
}

- (NSString *)eventDescription{
    return [JDCloudPlayLogModel descriptionWithEvent:self.event];
}

@end
