//
//  JDCloudGestureModel.h
//  IJKMediaDemo
//
//  Created by 王亚伟 on 2018/9/18.
//  Copyright © 2018年 wangyawei All rights reserved.
//

#import <Foundation/Foundation.h>
#import "JDCloudPrivateDefine.h"

@class JDCloudPlayerGestureModel;
@protocol JDCloudPlayerGestureModelDelegate <NSObject>

@required
//单击屏幕
- (void)onSingleClicked;

//双击屏幕
- (void)onDoubleClicked;

//手势水平移动偏移量
- (void)horizontalOrientationMoveOffset:(float)moveOffset gestureState:(UIGestureRecognizerState)gestureState;

@optional
//手势在view左侧区域，上下移动时 对亮度的设置
- (void)jdCloudPlayerGestureModel:(JDCloudPlayerGestureModel*)jdCloudPlayerGestureModel brightnessDirection:(UISwipeGestureRecognizerDirection)direction;

//手势在view左侧区域，上下移动时 对音量的设置
- (void)jdCloudPlayerGestureModel:(JDCloudPlayerGestureModel*)jdCloudPlayerGestureModel volumeDirection:(UISwipeGestureRecognizerDirection)direction;

/*
 * 功能：手势移动方向
 * 参数 ：JDCloudGestureModel 对象自己
 state 手势当前状态（开始、移动、结束）
 moveOrientation 手势移动方向
 
 */
- (void)jdCloudPlayerGestureModel:(JDCloudPlayerGestureModel*)jdCloudPlayerGestureModel state:(UIGestureRecognizerState)state moveOrientation:(JDCloudOrientation)moveOrientation;


@end

@interface JDCloudPlayerGestureModel : NSObject

@property (nonatomic, weak) id<JDCloudPlayerGestureModelDelegate>delegate;

/*
 * 功能 ：手势添加到特定的view中
 */
- (void)setView:(id)view;

/*
 * 功能 ：设置手势禁用功能
 */
- (void)setEnableGesture:(BOOL)enableGesture;

@end
