//
//  JDCloudPlayerPopLayer.h
//  IJKMediaDemo
//
//  Created by 王亚伟 on 2018/9/18.
//  Copyright © 2018年 wangyawei All rights reserved.
//

#import <UIKit/UIKit.h>
#import "JDCloudPlayerLoadingView.h"
#import "JDCloudPlayerErrorView.h"
#import "JDCloudUtil.h"

@class JDCloudPlayerPopLayer;
@protocol JDCloudPopLayerDelegate <NSObject>

/*
 * 功能 ：点击返回时操作
 * 参数 ：popLayer 对象本身
 */
- (void)onBackClickedWithPopLayer:(JDCloudPlayerPopLayer *)popLayer ;

/*
 * 功能 ：提示错误信息时，当前按钮状态
 * 参数 ：type 错误类型
 */
- (void)showPopViewWithType:(JDCloudErrorType)type;

@end

@interface JDCloudPlayerPopLayer : UIView

@property (nonatomic, weak) id<JDCloudPopLayerDelegate>delegate;

/*
 * 功能 ：根据不同code，展示弹起的消息界面
 * 参数 ： code ： 事件
 popMsg ：自定义消息
 */
- (void)showPopViewWithCode:(JDCloudPlayerPopCode)code popMsg:(NSString *)popMsg;

@end
