//
//  LogListView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/25.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "LogListView.h"
#import "JDCloudPlayLogModel.h"
#import "VideoPlayListTableViewCell.h"

@interface LogListView()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong) UITableView *listTableView;                                 //显示列表的TableView
@property (nonatomic, strong)NSMutableArray<JDCloudPlayLogModel *> *logArray;             //日志列表

@property (nonatomic, weak) id<JDVideoPlayContextProtocol> context;                       //播放器通过上下文传过来

@end

@implementation LogListView

- (instancetype)initWithFrame:(CGRect)frame withContext:(id<JDVideoPlayContextProtocol>)context
{
    self = [super initWithFrame:frame];
    if (self) {
        self.context = context;
        [self setupSubviews];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子试图
//初始化子试图
- (void)setupSubviews
{
    [self addSubview:self.listTableView];
    [JDStaticTools setExtraCellLineHidden:self.listTableView];
    self.logArray = [NSMutableArray array];
}

- (UITableView*)listTableView{
    if (!_listTableView) {
        _listTableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, self.frame.size.height)];
        _listTableView.dataSource = self;
        _listTableView.delegate = self;
        _listTableView.backgroundColor = [UIColor clearColor];
        _listTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    }
    return _listTableView;
}

#pragma mark -
#pragma mark - 初始化数据
- (void)playHappenEvent:(JDCloudPlayerEvent)event
{
    JDCloudPlayLogModel *logModel = [[JDCloudPlayLogModel alloc] initWithEvent:event];
    [self.logArray insertObject:logModel atIndex:0];
    [self.listTableView reloadData];
}

#pragma mark -
#pragma mark - UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.logArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString* CellIdentifier = @"CellThree";
    VideoPlayListTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (!cell) {
        cell = [[[NSBundle mainBundle] loadNibNamed:@"VideoPlayListTableViewCell" owner:self options:nil] objectAtIndex:2];
        cell.backgroundColor = [UIColor clearColor];
        [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
    }
    if (indexPath.row < self.logArray.count){
        JDCloudPlayLogModel* model = self.logArray[indexPath.row];
        [cell setupLogModel:model withSelectedRow:indexPath.row WithCurrRow:indexPath.row];
    }
    return cell;
}

- (CGFloat) tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 46.;
}




@end
