//
//  VideoPlayListTableViewCell.h
//  jdcloud_ios_live_demo
//
//  Created by pengdandan on 2018/9/17.
//  Copyright © 2018年 pengdandan. All rights reserved.
//  播放的列表cell、离线视频列表、日志列表

#import <UIKit/UIKit.h>
#import "VideoPlayListModel.h"
#import <Photos/PHFetchResult.h>
#import "JDCloudPlayLogModel.h"

@class VideoPlayListTableViewCell;

@protocol VideoPlayListTableViewCellDelegate<NSObject>

- (void)refreshVidePlayImageWithCell:(VideoPlayListTableViewCell *)cell;

@end

@interface VideoPlayListTableViewCell : UITableViewCell

@property (nonatomic,weak) id<VideoPlayListTableViewCellDelegate>delegate;

//视频播放
@property (weak, nonatomic) IBOutlet UIImageView *videoImageView;
@property (weak, nonatomic) IBOutlet UILabel *videoTimeLabel;
@property (weak, nonatomic) IBOutlet UILabel *videoTitleLabel;

//离线视频
@property (weak, nonatomic) IBOutlet UIImageView *offLineImageView;
@property (weak, nonatomic) IBOutlet UILabel *offLineTitleLabel;
@property (weak, nonatomic) IBOutlet UILabel *offLineUsedNumLabel;

//播放日志
@property (weak, nonatomic) IBOutlet UILabel *logTimeLabel;
@property (weak, nonatomic) IBOutlet UILabel *logTitleLabel;


//播放别表
- (void)setupVideoPlayListModel:(VideoPlayListModel *)model withSelectedRow:(NSInteger)selectedRow WithCurrRow:(NSInteger)currRow;

//离线视频
- (void)setupOffLineVideoModelArr:(PHFetchResult *)fetchResult withSelectedRow:(NSInteger)selectedRow WithCurrRow:(NSInteger)currRow;

//日志
- (void)setupLogModel:(JDCloudPlayLogModel *)model withSelectedRow:(NSInteger)selectedRow WithCurrRow:(NSInteger)currRow;

@end
