//
//  JDCloudPlayerSpeedListView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/12.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudPlayerSpeedListView.h"

@interface JDCloudPlayerSpeedListView ()

@property (nonatomic, strong) NSArray<UIButton *> *buttons;       //总共的倍速个数
@property (nonatomic, strong) NSArray* btnTitleArr;               //总共的清晰度的titleArr
@property (nonatomic, strong) NSString *selectedTitle;            //传过来的选中的清晰度title

@property (nonatomic, weak) id<JDVideoPlayContextProtocol> context;

@end

@implementation JDCloudPlayerSpeedListView

- (instancetype)initWithFrame:(CGRect)frame withContext:(id<JDVideoPlayContextProtocol>)context  selectedTitle:(NSString*)title
{
    if (self = [super initWithFrame:frame]) {
        self.frame = CGRectMake(ScreenWidth - 250, 0, 250, ScreenHeight);
        self.selectedTitle = title;
        self.context = context;
        [self addSubViews];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子试图
- (void)addSubViews
{
    self.backgroundColor = RGBACOLOR(0, 0, 0, 0.7);
    
    self.btnTitleArr = @[@"2倍速",@"1.5倍速",@"1.25倍速",@"1倍速",@"0.75倍速",@"0.5倍速"];
    
    self.buttons = [self creatButtonsWithCount:6];
    
    //选中的button
    for (int i = 0; i<self.btnTitleArr.count; i++) {
        if ([self.selectedTitle isEqualToString:self.btnTitleArr[i]]) {
            [self buttonClickAction:self.buttons[i]];
        }
    }
}

#pragma mark -
#pragma mark - 点击事件
- (void)buttonClickAction:(UIButton *)sender
{
    UIButton* button = (UIButton *)sender;
    button.selected = YES;

    switch (button.tag) {
        case 100:
        {
            self.selectedTitle = @"2倍速";
        }
            break;
        case 101:
        {
            self.selectedTitle = @"1.5倍速";
        }
            break;
        case 102:
        {
            self.selectedTitle = @"1.25倍速";
        }
            break;
        case 103:
        {
            self.selectedTitle = @"1倍速";
        }
            break;
        case 104:
        {
            self.selectedTitle = @"0.75倍速";
        }
            break;
        case 105:
        {
            self.selectedTitle = @"0.5倍速";
        }
            break;
        case 106:
        {
            self.selectedTitle = @"2倍速";
        }
            break;
        default:
            break;
    }
    
    NSDictionary *dataDic = [NSDictionary dictionaryWithObject:self.selectedTitle forKey:@"title"];
    [[NSNotificationCenter defaultCenter] postNotificationName:@"JDVideoPlaySpeedChangNotification" object:nil userInfo:dataDic];
    //倍速改变画面进度
    
    //移除
    [self removeFromSuperview];
}


#pragma mark -
#pragma mark - 功能函数
//button
- (NSArray<UIButton *> *)creatButtonsWithCount:(NSInteger)count {
    
    CGFloat height = (ScreenHeight-30)/8;
   
    NSMutableArray<UIButton *> *array = [NSMutableArray arrayWithCapacity:count];
    
    for (NSInteger index = 0; index < count; index++)
    {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        button.frame = CGRectMake(0, 30 + index * height, self.frame.size.width, height);
        button.tag = 100 + index;
        [button setTitle:self.btnTitleArr[index] forState:UIControlStateNormal];
        [button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [button setTitleColor:[JDStaticTools  colorWithHexString:kJDVCThemeColor] forState:UIControlStateSelected];
        button.titleLabel.font = [UIFont systemFontOfSize:16.0 * SCALE_FONT];
        [button addTarget:self action:@selector(buttonClickAction:) forControlEvents:UIControlEventTouchUpInside];
        [array addObject:button];
        [self addSubview:button];
    }
    return [array copy];
}

//点击其他区域 view移除
- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event{
   // UITouch *touch  = touches.anyObject;
    [self removeFromSuperview];
   // if ([touch.view isKindOfClass:[self class]]) {
       // [self removeFromSuperview];
   // }
}

@end
