//
//  JDCloudPlayerProgressView.h
//  IJKMediaDemo
//
//  Created by 王亚伟 on 2018/9/18.
//  Copyright © 2018年 wangyawei All rights reserved.
//

#import <UIKit/UIKit.h>
#import "JDCloudPlayerViewSlider.h"

@class JDCloudPlayerProgressView;
@protocol JDCloudPlayerVodProgressViewDelegate <NSObject>
/*
 * 功能 ： 移动距离
 参数 ： dragProgressSliderValue slide滑动长度
 event 手势事件，点击-移动-离开
 */
- (void)jdCloudVodProgressView:(JDCloudPlayerProgressView *)progressView dragProgressSliderValue:(float)value event:(UIControlEvents)event;
@end

@interface JDCloudPlayerProgressView : UIView

@property (nonatomic, weak  ) id<JDCloudPlayerVodProgressViewDelegate>delegate;
@property (nonatomic, assign) float progress;                  //设置sliderValue
@property (nonatomic, assign) float loadTimeProgress;          //设置缓冲progress

@property (nonatomic, strong) JDCloudPlayerViewSlider *playSlider;  //进度条，currentTime
/*
 * 功能 ：更新进度条
 * 参数 ：currentTime 当前播放时间
 durationTime 播放总时长
 */
- (void)updateProgressWithCurrentTime:(float)currentTime durationTime:(float)durationTime;

@end
