//
//  JDCloudFirstGestureGuideView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/22.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudFirstGestureGuideView.h"

@interface JDCloudFirstGestureGuideView()<UIGestureRecognizerDelegate>

@property (nonatomic, strong) UIImageView* imageViewOne;
@property (nonatomic, strong) UIImageView* imageViewTwo;
@property (nonatomic, strong) UIImageView* imageViewThree;
@property (nonatomic, strong) UIImageView* imageViewFour;
@property (nonatomic, strong) UIImageView* imageViewFive;

@property (nonatomic, strong) UILabel* labelOne;
@property (nonatomic, strong) UILabel* labelTwo;
@property (nonatomic, strong) UILabel* labelThree;
@property (nonatomic, strong) UILabel* labelFour;
@property (nonatomic, strong) UILabel* labelFive;

@property (nonatomic, strong) UITapGestureRecognizer *singleClick;       //单击手势

@end

@implementation JDCloudFirstGestureGuideView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight)];
    if (self) {
        [self addSubviews];
        [self addGesture];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子试图
- (void)addSubviews
{
    self.backgroundColor = RGBACOLOR(0, 0, 0, 0.5);
    
    //亮度
    self.imageViewOne = [[UIImageView alloc]initWithFrame:CGRectMake((ScreenWidth/3 - 147/2)/2 + 20, (ScreenHeight - 192/2)/2 , 147/2, 192/2)];
    _imageViewOne.image = [UIImage imageNamed:@"控制亮度"];
    [self addSubview:_imageViewOne];
    
    self.labelOne = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 180, 30)];
    self.labelOne.center = CGPointMake(self.imageViewOne.center.x, self.imageViewOne.center.y + 80);
    self.labelOne.text = @"上下滑动，控制亮度";
    self.labelOne.textColor = [UIColor whiteColor];
    self.labelOne.font = [UIFont systemFontOfSize:15.* SCALE_FONT];
    [self addSubview:self.labelOne];
    
    //双击放大
    self.imageViewTwo = [[UIImageView alloc]initWithFrame:CGRectMake(ScreenWidth/3 + (ScreenWidth/3 - 179/2)/2, (ScreenHeight - 216/2)/2, 179/2, 216/2)];
    _imageViewTwo.image = [UIImage imageNamed:@"双击-放大视频"];
    [self addSubview:_imageViewTwo];
    
    self.labelTwo = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 180, 30)];
    self.labelTwo.center = CGPointMake(self.imageViewTwo.center.x, self.imageViewTwo.center.y + 80);
    self.labelTwo.text = @"双击，播放/暂停";
    self.labelTwo.textColor = [UIColor whiteColor];
    self.labelTwo.font = [UIFont systemFontOfSize:15.* SCALE_FONT];
    [self addSubview:self.labelTwo];
    
    //音量
    self.imageViewThree = [[UIImageView alloc]initWithFrame:CGRectMake(ScreenWidth*2/3 + (ScreenWidth/3 - 147/2)/2 - 20, (ScreenHeight - 182/2)/2, 147/2, 182/2)];
    _imageViewThree.image = [UIImage imageNamed:@"控制音量"];
    [self addSubview:_imageViewThree];
    
    self.labelThree = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 180, 30)];
    self.labelThree.center = CGPointMake(self.imageViewThree.center.x, self.imageViewThree.center.y + 80);
    self.labelThree.text = @"上下滑动，控制音量";
    self.labelThree.textColor = [UIColor whiteColor];
    self.labelThree.font = [UIFont systemFontOfSize:15.* SCALE_FONT];
    [self addSubview:self.labelThree];
    
    //快退
    self.imageViewFour = [[UIImageView alloc]initWithFrame:CGRectMake((ScreenWidth/2 - 163/2)/2+10, (ScreenHeight - 177/2)/2 , 163/2, 177/2)];
    _imageViewFour.image = [UIImage imageNamed:@"快退图"];
    [self addSubview:_imageViewFour];
    self.imageViewFour.hidden = YES;
    
    self.labelFour = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 180, 30)];
    self.labelFour.center = CGPointMake(self.imageViewFour.center.x, self.imageViewFour.center.y + 80);
    self.labelFour.text = @"左滑，快退";
    self.labelFour.textColor = [UIColor whiteColor];
    self.labelFour.font = [UIFont systemFontOfSize:15.* SCALE_FONT];
    [self addSubview:self.labelFour];
    self.labelFour.hidden = YES;
    
    //快进
    self.imageViewFive = [[UIImageView alloc]initWithFrame:CGRectMake(ScreenWidth/2 + (ScreenWidth/2 - 238/2)/2 - 10, (ScreenHeight - 177/2)/2, 238/2, 177/2)];
    _imageViewFive.image = [UIImage imageNamed:@"快进图"];
    [self addSubview:_imageViewFive];
    self.imageViewFive.hidden = YES;
    
    self.labelFive = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 180, 30)];
    self.labelFive.center = CGPointMake(self.imageViewFive.center.x, self.imageViewFive.center.y + 80);
    self.labelFive.text = @"左滑，快进";
    self.labelFive.textColor = [UIColor whiteColor];
    self.labelFive.font = [UIFont systemFontOfSize:15.* SCALE_FONT];
    [self addSubview:self.labelFive];
    self.labelFive.hidden = YES;
    
}

//单击手势
- (void)addGesture
{
    self.singleClick = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(singleClickGuestTap:)];
    self.singleClick.delegate = self;
    [self addGestureRecognizer:self.singleClick];
}

- (void)singleClickGuestTap:(UITapGestureRecognizer *)sender
{
    if (self.imageViewFour.hidden) {
        self.imageViewFour.hidden = NO;
        self.labelFour.hidden = NO;
        self.imageViewFive.hidden = NO;
        self.labelFive.hidden = NO;
        
        self.imageViewOne.hidden = YES;
        self.labelOne.hidden = YES;
        self.imageViewTwo.hidden = YES;
        self.labelTwo.hidden = YES;
        self.imageViewThree.hidden = YES;
        self.labelThree.hidden = YES;
    }
    else{
        self.imageViewFour.hidden = YES;
        self.labelFour.hidden = YES;
        self.imageViewFive.hidden = YES;
        self.labelFive.hidden = YES;
        [self removeFromSuperview];
    }
}


@end
