//
//  JDCloudPlayerViewGestureView.h
//  IJKMediaDemo
//
//  Created by 王亚伟 on 2018/9/18.
//  Copyright © 2018年 wangyawei All rights reserved.
//

#import <UIKit/UIKit.h>
#import "JDCloudPrivateDefine.h"

@class JDCloudPlayerGestureView;
@protocol JDCloudPlayerGestureViewDelegate <NSObject>

//单击屏幕
- (void)onSingleClickedWithJDCloudGestureView:(JDCloudPlayerGestureView *)gestureView;

//双击屏幕
- (void)onDoubleClickedWithJDCloudGestureView:(JDCloudPlayerGestureView *)gestureView;

//手势水平移动偏移量
- (void)horizontalOrientationMoveOffset:(float)moveOffset gestureState:(UIGestureRecognizerState)gestureState;

@end


@interface JDCloudPlayerGestureView : UIView

@property (nonatomic, weak) id<JDCloudPlayerGestureViewDelegate>delegate;

@property (nonatomic, assign) BOOL isSeeking;

// 是否禁用手势（双击、滑动）
- (void)setEnableGesture:(BOOL)enableGesture;

// 传递
- (void)setSeekTime:(NSTimeInterval)time direction:(UISwipeGestureRecognizerDirection)direction;


@end
