//
//  JDCloudOnlyAudioPlayView.m
//  jdcloud_ios_live_demo
//
//  Created by 彭丹丹 on 2018/10/22.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudOnlyAudioPlayView.h"
#import "JDCloudPlaySetsModel.h"
#import "MoreBottomAlertView.h"

@interface JDCloudOnlyAudioPlayView()

@property (nonatomic, strong) UILabel* title;

@property (nonatomic, strong) UIButton* leftBtn;

@property (nonatomic, weak) id<JDVideoPlayContextProtocol> context;

@property (nonatomic, strong) JDCloudPlaySetsModel *playSetsModel;

@end

@implementation JDCloudOnlyAudioPlayView

- (instancetype)initWithFrame:(CGRect)frame WithContext:(id<JDVideoPlayContextProtocol>)context
{
    self = [super initWithFrame:frame];
    if (self) {
        self.context = context;
        [self setupSubviews];
    }
    return self;
}

#pragma mark -
#pragma mark - 初始化子视图
- (void)setupSubviews{
    //背景色
    [self addSubViews];
}

//子试图
- (void)addSubViews
{
    //title
    self.title = [[UILabel alloc]init];
    self.title.textAlignment = NSTextAlignmentCenter;
    self.title.font = [UIFont systemFontOfSize:14 * SCALE_FONT];
    self.title.textColor = [UIColor whiteColor];
    self.title.text = @"纯音频播放中...";
    [self addSubview:self.title];
    
    //返回
    self.leftBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    self.leftBtn.userInteractionEnabled = YES;
    self.leftBtn.backgroundColor = RGBACOLOR(0, 0, 0, 0.1);
    [self.leftBtn setImage:[UIImage imageNamed:@"返回视频推流"] forState:UIControlStateNormal];
    [self.leftBtn setTitle:@"返回视频播放" forState:UIControlStateNormal];
    [self.leftBtn addTarget:self action:@selector(backAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:self.leftBtn];
}

- (void)layoutSubviews{
    [super layoutSubviews];
    if ([JDStaticTools isInterfaceOrientationPortrait]) { //竖屏
        
        self.frame = CGRectMake(44, 44, self.context.jdCloudPlayer.playerView.frame.size.width - 88, self.context.jdCloudPlayer.playerView.frame.size.height - 88);
        float width = self.frame.size.width;
        float height = self.frame.size.height;
        self.title.frame = CGRectMake(0, (height-21)/2 - 30, width, 21);
        self.leftBtn.frame = CGRectMake(30, (height-21)/2, width - 60, 44);

    }else{  //横屏
        
        self.frame = CGRectMake(230, 144, ScreenWidth - 460, ScreenHeight-288);
        float width = self.frame.size.width;
        float height = self.frame.size.height;
        self.title.frame = CGRectMake(0, (height-21)/2 - 30, width, 21);
        self.leftBtn.frame = CGRectMake(0, (height-21)/2, width, 44);
    }
}

#pragma mark -
#pragma mark - 返回视频播放
- (void)backAction
{
    self.context.jdCloudPlayer.isOnlyAudio = NO;
    SharedSetVideoPlayManager.isOnlyAudio = NO;
    [self removeFromSuperview];
    //纯音频停止后，重新设置按钮选中状态
    [[NSNotificationCenter defaultCenter] postNotificationName:@"JDVideoPlayOnlyAudioChangeNotification" object:nil];
}

@end
