//
//  JDCloudProgressView.m
//  jdcloud_ios_live_demo
//
//  Created by 王亚伟 on 2018/11/12.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudProgressView.h"

@interface JDCloudProgressView()

@property(nonatomic,strong)CALayer *backgroudLayer;
@property(nonatomic,strong)UILabel *progressTextLabel;
@property(nonatomic,strong)CALayer *progressLayer;
@property(nonatomic,assign)BOOL isGifProgress;



@end

@implementation JDCloudProgressView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor clearColor];
        [self.layer addSublayer:self.backgroudLayer];
        [self.layer addSublayer:self.progressLayer];
        [self addSubview:self.progressTextLabel];
    }
    return self;
}

-(void)setIsGifProgress:(BOOL)isGifProgress
{
    _isGifProgress = isGifProgress;
    if (_isGifProgress) {
        _progressTextLabel.text = @"生成GIF图片中";
    } else {
        _progressTextLabel.text = @"截取视频中";
    }
}

-(void)setProgress:(CGFloat)progress
{
//    [CATransaction begin];
//    [CATransaction setDisableActions:YES];
    _progressLayer.position = CGPointMake(progress * self.frame.size.width/2, 8);
    _progressLayer.bounds = CGRectMake(0, 2, progress * self.frame.size.width ,14);
//    [CATransaction commit];

    if (progress == 1) {
        if (_isGifProgress) {
            _progressTextLabel.text = @"GIF图片生成完成";
        } else {
            _progressTextLabel.text = @"截取视频完成";
        }
    }
}

-(CALayer *)progressLayer
{
    if (!_progressLayer) {
        _progressLayer = [CALayer layer];
        _progressLayer.bounds = CGRectMake(0, 2, 0 ,14);
        _progressLayer.position = CGPointMake(0, 8);
        _progressLayer.backgroundColor = [UIColor colorWithRed:108.0/255.0 green:170.0/255.0 blue:245.0/255.0 alpha:1].CGColor;
        _progressLayer.cornerRadius =  7;
    }
    return _progressLayer;
}

-(CALayer *)backgroudLayer
{
    if (!_backgroudLayer) {
        _backgroudLayer = [CALayer layer];
        _backgroudLayer.bounds = CGRectMake(0, 2, 0 ,14);
        _backgroudLayer.position = CGPointMake(0, 8);
        _backgroudLayer.backgroundColor = [UIColor lightGrayColor].CGColor;
        _backgroudLayer.cornerRadius =  7;
    }
    return _backgroudLayer;
}

-(UILabel *)progressTextLabel
{
    if (!_progressTextLabel) {
        _progressTextLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 16, self.frame.size.width,16)];
        _progressTextLabel.backgroundColor = [UIColor clearColor];
        _progressTextLabel.text = @"生成GIF图片中";
        _progressTextLabel.font = [UIFont systemFontOfSize:14];
        _progressTextLabel.textColor = [UIColor whiteColor];
        _progressTextLabel.textAlignment = NSTextAlignmentRight;
    }
    return _progressTextLabel;
}

@end
