//
//  JDCloudVideoGifAllImagesView.m
//  jdcloud_ios_live_demo
//
//  Created by 王亚伟 on 2018/11/7.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import "JDCloudVideoGifAllImagesView.h"
#import "JDStaticTools.h"

//self.rightTimeLabel.text = [JDStaticTools stringWithNSTimeInterval:self.context.jdCloudPlayer.duration];

@interface JDCloudVideoGifAllImagesView()

@property(nonatomic,strong)NSMutableArray *showedImagesArray;

@end

@implementation JDCloudVideoGifAllImagesView

- (void)dealloc
{
    _showedImagesArray = nil;
}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        _showedImagesArray = [NSMutableArray array];
    }
    return self;
}

- (void)addImagePaths:(NSArray *)imagePaths
{
    if (imagePaths.count > 0) {
        for (NSString *imagePath in imagePaths) {
            if (imagePath) {
                if (![_showedImagesArray containsObject:imagePath]) {
                    [_showedImagesArray addObject:imagePath];
                    UIImage *image = [UIImage imageWithContentsOfFile:imagePath];
                    CGFloat imageWidth = image.size.width;
                    CGFloat imageHeight = image.size.height;
                    CGFloat showImageWidth = imageHeight*self.frame.size.width/(self.frame.size.height*_imagesTotalCount);
                    CGRect rect = CGRectMake((imageWidth - showImageWidth)/2 ,0,showImageWidth, imageHeight);
                    
                    UIImageView *imageView = [[UIImageView alloc] init];
                    imageView.image=[UIImage imageWithCGImage:CGImageCreateWithImageInRect([image CGImage], rect)];
                    imageView.clipsToBounds = YES;
                    imageView.contentMode = UIViewContentModeScaleAspectFit;
                    CGFloat imageViewWidth = self.frame.size.width/_imagesTotalCount;
                    CGFloat offX = imageViewWidth * (_showedImagesArray.count - 1);
                    imageView.frame = CGRectMake(offX, 0, imageViewWidth, self.frame.size.height);
                    [self addSubview:imageView];
                }
            }
        }
    }
}

-(void)setAllGifImages:(NSArray *)allGifImages
{
    [self.subviews enumerateObjectsUsingBlock:^(__kindof UIView * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if ([obj isMemberOfClass:[UIImageView class]]) {
            [obj removeFromSuperview];
        }
    }];
    for (int i = 0; i < allGifImages.count; i++) {
        UIImage *image = [UIImage imageWithContentsOfFile:allGifImages[i]];
        CGFloat imageWidth = image.size.width;
        CGFloat imageHeight = image.size.height;
        CGFloat showImageWidth = imageHeight*self.frame.size.width/(self.frame.size.height*allGifImages.count);
        CGRect rect = CGRectMake((imageWidth - showImageWidth)/2 ,0,showImageWidth, imageHeight);

        UIImageView *imageView = [[UIImageView alloc] init];
        imageView.image=[UIImage imageWithCGImage:CGImageCreateWithImageInRect([image CGImage], rect)];
        imageView.clipsToBounds = YES;
        imageView.contentMode = UIViewContentModeScaleAspectFit;
        imageView.frame = CGRectMake(self.frame.size.width/allGifImages.count * i, 0, self.frame.size.width/allGifImages.count, self.frame.size.height);
        [self addSubview:imageView];
    }
}

@end
