//
//  JDCloudVideoTrimmerView.h
//  jdcloud_ios_live_demo
//
//  Created by 王亚伟 on 2018/11/7.
//  Copyright © 2018年 pengdandan. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>

NS_ASSUME_NONNULL_BEGIN


@protocol JDCloudVideoTrimmerDelegate;

@interface JDCloudVideoTrimmerView : UIView

@property (strong, nonatomic) UIColor *themeColor;

@property (assign, nonatomic) CGFloat maxLength;

@property (assign, nonatomic) CGFloat minLength;

@property (strong, nonatomic) UIColor *trackerColor;

@property (strong, nonatomic, nullable) UIImage *leftThumbImage;

@property (strong, nonatomic, nullable) UIImage *rightThumbImage;

@property (assign, nonatomic) CGFloat borderWidth;

@property (assign, nonatomic) CGFloat thumbWidth;

@property (assign, nonatomic) NSInteger thumbnailCount;

@property (weak, nonatomic, nullable) id<JDCloudVideoTrimmerDelegate> delegate;

- (instancetype)initWithFrame:(CGRect)frame;

- (void)addThumbnailPaths:(NSArray *)thumbnailPaths;

- (void)resetSubviewsWithTotalTime:(CGFloat)totalTime
                         StartTime:(CGFloat)startTime
                          duration:(CGFloat)duration;

@end

NS_ASSUME_NONNULL_END


@protocol JDCloudVideoTrimmerDelegate <NSObject>

- (void)trimmerDidChangeLeftPosition:(CGFloat)startTime rightPosition:(CGFloat)endTime;

@end
