//
//  JDSBGMTimeLineItem.h
//  jdcloud_shortvideo_ios
//
//  Created by 杜治全 on 2019/5/13.
//  Copyright © 2019 com.jdcloud. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import "JDSTimeLineItem.h"

NS_ASSUME_NONNULL_BEGIN

/*!
 @class JDSBGMTimeLineItem
 @abstract 表示时间线上的一个BGM片段
 @discussion 时间线上一个BGM片段的各种属性设置
 */
@interface JDSBGMTimeLineItem : JDSTimeLineItem
/*!
 @abstract BGM的原始asset
 */
@property (nonatomic, strong, readonly) AVAsset *asset;
/*!
 @abstract BGM的实际asset(AVComposition)
 */
@property (nonatomic, strong) AVAsset *innerAsset;
/*!
 @abstract BGM在原始数据中的时间范围
 */
@property (nonatomic, assign) CMTimeRange timeRangeInAsset;

/*!
 @abstract Movie在时间线上的时间范围
 */
@property (nonatomic, assign) CMTimeRange timeRangeInWhole;

/*!
 @abstract BGM的时长，不可修改
 */
@property (nonatomic, assign) CMTime duration;
/*!
 @abstract BGM的文件路径
 */
@property (nonatomic, strong) NSString *filePath;
/*!
 @abstract BGM的音量
 */
@property (nonatomic, assign) double volume;
/*!
 @abstract BGM是否静音
 */
@property (nonatomic, assign) BOOL mute;
/*!
 @abstract BGM的倍速
 */
@property (nonatomic, assign) double rate;

/*!
 @abstract reload
 */
- (void)reload;

@end

NS_ASSUME_NONNULL_END
