//
//  JDCloudOptionModel.h
//

#import <Foundation/Foundation.h>
#import "JDCloudPlayerDefine.h"

/*!
 @class JDCloudOptionModel
 @abstract 京东云播放器SDK-配置参数类
 @discussion 本类包含了播放器中一些默认配置参数
 */
@interface JDCloudOptionModel : NSObject

/*!
 @abstract 是否开启硬解码，默认开启
 */
@property(nonatomic,assign)BOOL videotoolbox;

/*!
 @abstract 是否纯音播放
 */
@property(nonatomic,assign)NSInteger videotoolboxMaxFrameWidth;

/*!
 @abstract 超时时间，默认30秒
 */
@property(nonatomic,assign)NSInteger timeout;

/*!
 @abstract 最大帧率，默认30
 */
@property(nonatomic,assign)NSInteger maxFps;

/*!
 @abstract 帧率，默认30
 */
@property(nonatomic,assign)NSInteger fps;

/*!
 @abstract 是否开启播放器缓存
 */
@property(nonatomic,assign)BOOL isCache;

/*!
 @abstract 播放器缓存路径
 */
@property(nonatomic,strong)NSString *cachePath;

/*!
 @abstract 缓存大小
 */
@property(nonatomic,assign) NSInteger cacheSize;

/*!
@abstract 是否开启精准seek 默认为NO
*/
@property(nonatomic,assign) BOOL enableAccurateSeek;

/*!
@abstract 精准seek超时时间，默认5秒
*/
@property(nonatomic,assign) NSInteger accurateSeekTimeout;

/*!
 @abstract 视频格式
 */
@property(nonatomic,assign) JDCloudPlayerVideoFormat videoFormat;

/*!
 @abstract 播放器播放声音模式，当isSetAudioSessionCategory为YES的时候，为PlayAndRecord，
           为NO时，播放器播放声音的模式是AVAudioSessionCategoryPlayback，默认为NO;
 */
@property(nonatomic,assign) BOOL isSetAudioSessionCategoryPlayAndRecord;

/*!
 @abstract 是否开启超分
 */
@property(nonatomic,assign)BOOL enableSuperRes;

@end

