//
//  JDMEDefines.h
//  GPUImage
//
//  Created by jdmt on 2019/4/8.
//  Copyright © 2019 com.jd. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

/*!
 @enum JDMEPreviewState
 @abstract  媒体编辑预览状态
 */
typedef NS_ENUM(NSUInteger, JDMEPreviewState){
    /*! 预览空闲状态*/
    JDMEPreviewState_Idle = 0,
    /*! 预览播放状态*/
    JDMEPreviewState_Play,
    /*! 预览暂停状态*/
    JDMEPreviewState_Pause
};

/*!
 @enum JDMEErrorCode
 @abstract  媒体编辑错误码
 */
typedef NS_ENUM(NSUInteger, JDMEErrorCode) {
    /*! 未知错误*/
    JDMEErrorCode_Unkown = 0,
    /*! 预览失败*/
    JDMEErrorCode_PreviewFail,
    /*! 合成失败*/
    JDMEErrorCode_ExportFail

};

/*!
 @enum JDMEOutputFormat
 @abstract  输出格式
 */
typedef NS_ENUM(NSUInteger, JDMEOutputFormat){
    /*! 输出mp4文件*/
    JDMEOutputFormat_MP4
};



NS_ASSUME_NONNULL_END
