//
//  JDMEOutputConfig.h
//  JDShortvideo
//
//  Created by jdmt on 2019/4/1.
//  Copyright © 2019 com.jd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CoreGraphics/CoreGraphics.h"
#import "JDMEDefines.h"

NS_ASSUME_NONNULL_BEGIN

/*!
 @class JDMEPreviewConfig
 @abstract 京东云编辑SDK-预览参数配置类
 @discussion 本类包含了所有视频编辑合成功能，输出参数的配置
 */
@interface JDMEPreviewConfig : NSObject

/*!
 @abstract 预览分辨率
 */
@property (nonatomic, assign) CGSize resolution;

/*!
 @abstract 预览分辨率
 */
@property (nonatomic, assign) CGFloat frameRate;


@end

/*!
 @class JDMEOutputConfig
 @abstract 京东云编辑SDK-导出参数配置类
 @discussion 本类包含了所有视频编辑合成功能，输出参数的配置
 */
@interface JDMEOutputConfig : NSObject

/*!
 @abstract 输出分辨率
 */
@property (nonatomic,assign) CGSize resolution;
/*!
 @abstract  输出码率
 */
@property (nonatomic, assign) CGFloat avKbps;
/*!
 @abstract  输出视频帧率
 */
@property (nonatomic, assign) CGFloat frameRate;
/*!
 @abstract  输出文件格式
 @discussion see JDMEOutputFormat
 */
@property (nonatomic, assign) JDMEOutputFormat format;
/*!
 @abstract  输出文件路径
 */
@property (nonatomic, strong) NSString* outputPath;


@end

NS_ASSUME_NONNULL_END
