//
//  JDSBaseLayerItemView.h
//  jdcloud_shortvideo_ios
//
//  Created by 熊勇 on 2019/5/14.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>

@class JDSLayerTimeLineItem;

NS_ASSUME_NONNULL_BEGIN

/*!
 @class JDSBaseLayerItemView
 @abstract 实现贴纸和字幕的基类
 @discussion 实现贴纸和字幕的基类
 */
@interface JDSBaseLayerItemView : UIView

/*!
 @abstract view对应的水印timelineItem
 */
@property (nonatomic, weak) JDSLayerTimeLineItem *timelineItem;
/*!
 @abstract view是否被选中，默认为NO
 */
//@property (nonatomic, assign) BOOL selected;

/*!
 @abstract view是否被选中，默认为NO
 */
@property (nonatomic, assign) BOOL canEdit;

/*!
 @abstract view是否被选中，默认为NO
 @param selected 是否被选中
 */
-(void)onItemViewSelected:(BOOL)selected;

/*!
 @abstract 随当前帧时间，更新ItemView内容
 @param time 当前帧时间
 */
-(void)onItemViewUpdateWithCurrentTime:(CMTime)time;

/*!
 @abstract 视频预览层传过来的点击事件
 @param recognizer 点击事件
 */
- (void)onTap:(UITapGestureRecognizer*)recognizer;


@end

NS_ASSUME_NONNULL_END
